Package: maplegend
Title: Legends for Maps
Version: 0.6.3
Authors@R: c(person("Timothée", "Giraud", email = "timothee.giraud@cnrs.fr",
    role = c("cre","aut"), comment = c(ORCID = "0000-0002-1932-3323")))
Description: Create legends for maps and other graphics. Thematic maps need to
    be accompanied by legible legends to be fully comprehensible. This package
    offers a wide range of legends useful for cartography, some of which may
    also be useful for other types of graphics. 
License: GPL-3
Depends: R (>= 4.1.0)
Imports: graphics, grDevices
Suggests: tinytest, covr
Encoding: UTF-8
RoxygenNote: 7.3.3
Language: en-US
URL: https://github.com/riatelab/maplegend/
BugReports: https://github.com/riatelab/maplegend/issues/
NeedsCompilation: no
Packaged: 2026-04-30 08:00:58 UTC; tim
Author: Timothée Giraud [cre, aut] (ORCID:
    <https://orcid.org/0000-0002-1932-3323>)
Maintainer: Timothée Giraud <timothee.giraud@cnrs.fr>
Repository: CRAN
Date/Publication: 2026-04-30 10:00:02 UTC
Built: R 4.6.0; ; 2026-05-01 20:10:16 UTC; unix

Package: maplegend
Title: Legends for Maps
Version: 0.6.3
Authors@R: c(person("Timothée", "Giraud", email = "timothee.giraud@cnrs.fr",
    role = c("cre","aut"), comment = c(ORCID = "0000-0002-1932-3323")))
Description: Create legends for maps and other graphics. Thematic maps need to
    be accompanied by legible legends to be fully comprehensible. This package
    offers a wide range of legends useful for cartography, some of which may
    also be useful for other types of graphics. 
License: GPL-3
Depends: R (>= 4.1.0)
Imports: graphics, grDevices
Suggests: tinytest, covr
Encoding: UTF-8
RoxygenNote: 7.3.3
Language: en-US
URL: https://github.com/riatelab/maplegend/
BugReports: https://github.com/riatelab/maplegend/issues/
NeedsCompilation: no
Packaged: 2026-04-30 08:00:58 UTC; tim
Author: Timothée Giraud [cre, aut] (ORCID:
    <https://orcid.org/0000-0002-1932-3323>)
Maintainer: Timothée Giraud <timothee.giraud@cnrs.fr>
Repository: CRAN
Date/Publication: 2026-04-30 10:00:02 UTC

<!-- README.md is generated from README.Rmd. Please edit that file -->

# maplegend

<!-- badges: start -->

[![R-CMD-check](https://github.com/riatelab/maplegend/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/riatelab/maplegend/actions/workflows/R-CMD-check.yaml)
[![Codecov test
coverage](https://codecov.io/gh/riatelab/maplegend/branch/main/graph/badge.svg)](https://app.codecov.io/gh/riatelab/maplegend?branch=main)
[![Project Status: Active – The project has reached a stable, usable
state and is being actively
developed.](https://www.repostatus.org/badges/latest/active.svg)](https://www.repostatus.org/#active)
<!-- badges: end -->

Create legends for maps and other graphics. Thematic maps need to be
accompanied by legible legends to be fully comprehensible. This package
offers a wide range of legends useful for cartography, some of which may
also be useful for other types of graphics.

## Installation

You can install the released version of `maplegend` from CRAN with:

``` r
install.packages("maplegend")
```

Alternatively, you can install the development version of `maplegend`
from GitHub (**dev** branch) with:

``` r
remotes::install_github("riatelab/maplegend", ref = "dev")
```

## Example

The main function is `leg()`. Its `type` argument defines the legend
type.

``` r
library(maplegend)
opar <- par(mar = c(1, 1, 1, 1), mfrow = c(1, 2))
plot.new()
plot.window(xlim = c(0, 1), ylim = c(0, 1))
leg(type = "prop", val = c(10, 50, 100), pos = "topleft")
leg(type = "choro", val = c(10, 20, 30, 40, 50), pos = "bottomleft")
leg(type = "typo", val = c("A", "B", "C"), pos = "top")
leg(type = "symb", val = c("A", "B", "C"), pos = "topright")
set.seed(46)
leg(type = "histo", val = hist(rnorm(1000), breaks = 5, plot = FALSE))
leg(type = "prop_line", val = c(5, 50, 100), pos = "bottom", lwd = 20)
leg(type = "grad_line", val = c(1, 4, 10, 15), pos = "bottomright", lwd = c(1, 5, 10))
box()
plot.new()
plot.window(xlim = c(0, 100), ylim = c(-50, 50))
leg(type = "prop", val = c(10, 50, 100), pos = "topleft", horiz = TRUE)
leg(type = "cont", val = c(10, 20, 30, 40, 50), pos = "bottomleft", horiz = TRUE)
leg(type = "choro", val = c(10, 20, 30, 40, 50), pos = c(40, 10), horiz = TRUE)
leg(type = "cont", val = c(10, 20, 30, 40, 50), pos = "left")
leg(
  type = "symb", val = c("Points", "Lines", "Polygons"), pos = "topright",
  pch = list(21, "৲", 22), cex = c(2, 2, 2), border = c("black", NA, "black"),
  pal = c("red", "blue", "grey90")
)
box()
par(opar)
```

![](man/figures/README-example-1.png)<!-- -->

It is possible to create composed legends with `leg_comp()` and
`leg_draw()`.

``` r
opar <- par(mar = c(1, 1, 1, 1))
plot.new()
plot.window(xlim = c(0, 1), ylim = c(0, 1))
leg_comp(type = "prop", val = c(10, 50, 100)) |>
  leg_comp(type = "typo", val = c("A", "B", "C")) |>
  leg_draw(pos = "top", bg = "lightblue", fg = "darkblue", frame_border = NA)
box()
par(opar)
```

![](man/figures/README-example2-1.png)<!-- -->

## Background

This package is mainly intended for the construction of legends in the
[`mapsf`](https://riatelab.github.io/mapsf/) package. However, it can
also be used independently of `mapsf` with `base` plots or even with
[`igraph`
plots](https://gist.github.com/rCarto/da5a4b0cd982a8c85cb847506fd2f415).

## Community Guidelines

One can contribute to the package through [pull
requests](https://github.com/riatelab/maplegend/pulls) and report issues
or ask questions [here](https://github.com/riatelab/maplegend/issues).  
This project uses [conventional
commits](https://www.conventionalcommits.org/en/v1.0.0-beta.3/) and
[semantic versioning](https://semver.org/).

leg_prop <- function(pos = "left",
                     val,
                     col = "tomato4",
                     alpha = NULL,
                     inches = .3,
                     val_max = NULL,
                     symbol = "circle",
                     border = "#333333",
                     lwd = .7,
                     title = "Legend Title",
                     title_cex = .8 * size,
                     val_cex = .6 * size,
                     val_rnd = 0,
                     val_dec = ".",
                     val_big = "",
                     frame = FALSE,
                     frame_border = fg,
                     bg = "#f7f7f7",
                     fg = "#333333",
                     size = 1,
                     self_adjust = FALSE,
                     return_bbox = FALSE,
                     box_cex,
                     adj = c(0, 0)) {
  # spacings
  x_spacing <- xinch(par("csi")) / 4
  y_spacing <- yinch(par("csi")) / 4

  # color mgmt
  col <- ifelse(!is.null(alpha), get_hex_pal(col, alpha), col)
  border <- border[[1]]
  lwd <- lwd[[1]]

  # values & values labels
  val <- unique(val)
  if (self_adjust == TRUE) {
    val <- self_adjust_v(val, inches, val_cex)
  }
  val <- sort(val, decreasing = TRUE)
  n_val <- length(val)
  valleg <- get_val_rnd(val = val, val_rnd = val_rnd, val_dec = val_dec, val_big = val_big)

  # title dimensions
  title_dim <- get_title_dim(title, title_cex)

  # adjust max_val
  if (is.null(val_max)) {
    val_max <- max(val)
  }

  # largest symbol size
  symb_sizes <- list(inches = sqrt(val * inches * inches / val_max))
  symb_sizes$x <- xinch(symb_sizes$inches)
  symb_sizes$y <- yinch(symb_sizes$inches)
  inches <- max(symb_sizes$inches)
  symb_dim <- list(w = xinch(inches * 2), h = yinch(inches * 2))

  # label dimension
  labels_dim <- list(
    w = max(strwidth(valleg, units = "user", cex = val_cex, font = 1)),
    h_top = strheight(valleg[1], units = "user", cex = val_cex, font = 1) / 2,
    h_bottom = strheight(valleg[n_val], units = "user", cex = val_cex, font = 1) / 2
  )

  # legend dimension
  legend_dim <- list(
    w = x_spacing +
      max(
        title_dim$w,
        symb_dim$w + labels_dim$w + 2 * x_spacing
      ) +
      x_spacing,
    h = y_spacing +
      ifelse(title_dim$h != 0, title_dim$h + 2 * y_spacing * size, 0) +
      labels_dim$h_top + symb_dim$h + max(0, labels_dim$h_bottom - symb_sizes$y[n_val] * 2) +
      y_spacing
  )

  # get legend coordinates
  legend_coords <- get_legend_coords(
    pos = pos, legend_dim = legend_dim,
    adj = adj, frame = frame,
    x_spacing = x_spacing,
    y_spacing = y_spacing
  )

  # return legend coordinates only
  if (return_bbox) {
    return(invisible(legend_coords))
  }

  # display frame
  plot_frame(
    frame = frame, legend_coords = legend_coords,
    bg = bg, frame_border = frame_border,
    x_spacing = x_spacing, y_spacing = y_spacing
  )

  # display title
  plot_title(
    title = title, title_cex = title_cex, title_dim = title_dim,
    fg = fg, legend_coords = legend_coords,
    x_spacing = x_spacing, y_spacing = y_spacing
  )

  # display symbols & lines
  pal <- rep(NA, n_val)
  pal[1] <- col
  x <- rep(legend_coords$left + x_spacing + symb_sizes$x[1], n_val)
  y <- legend_coords$top - y_spacing -
    ifelse(title_dim$h != 0, title_dim$h + 2 * y_spacing * size, 0) -
    labels_dim$h_top - symb_sizes$y[1] * 2 + symb_sizes$y

  lwd_seg <- ifelse(lwd <= 1.5, lwd, 1.5)
  lwd_seg <- ifelse(lwd_seg >= .5, lwd_seg, .7)
  lwd <- ifelse(lwd >= .5, lwd, .7)

  if (symbol == "circle") {
    # line width within the circle
    x2 <- sqrt(symb_sizes$x[1]^2 -
      (symb_sizes$x[1] - (symb_sizes$x[1] * 2 - symb_sizes$x * 2))^2)
    segments(
      x0 = x[1] + x2[1],
      x1 = x[1] + x_spacing + symb_sizes$x[1],
      y0 = y[1] + symb_sizes$y[1],
      y1 = y[1] + symb_sizes$y[1],
      col = fg,
      lwd = lwd_seg
    )
    symbols(
      x = x,
      y = y,
      circles = symb_sizes$inches,
      bg = pal,
      fg = border,
      lwd = lwd,
      add = TRUE,
      inches = inches
    )
    segments(
      x0 = x[-1] + x2[-1],
      x1 = x[-1] + x_spacing + symb_sizes$x[1],
      y0 = y[-1] + symb_sizes$y[-1],
      y1 = y[-1] + symb_sizes$y[-1],
      col = fg,
      lwd = lwd_seg
    )
    segments(
      x0 = x,
      x1 = x + x2,
      y0 = y + symb_sizes$y,
      y1 = y + symb_sizes$y,
      col = border,
      lwd = lwd_seg
    )
    text(
      x = x + x_spacing + symb_sizes$x[1] + x_spacing,
      y = y + symb_sizes$y,
      labels = valleg, cex = val_cex, adj = c(0, 0.5), col = fg
    )
  }
  if (symbol == "square") {
    if (n_val > 1) {
      for (i in 2:n_val) {
        x[i] <- x[1] + (symb_sizes$x[1] - symb_sizes$x[i])
      }
    }
    symbols(
      x = x,
      y = y,
      squares = symb_sizes$inches,
      bg = pal,
      fg = border,
      lwd = lwd,
      add = TRUE,
      inches = inches * 2,
    )
    segments(
      x0 = x[1] + symb_sizes$x[1],
      x1 = x[1] + symb_sizes$x[1] + x_spacing,
      y0 = y + symb_sizes$y,
      y1 = y + symb_sizes$y,
      col = fg,
      lwd = lwd_seg
    )
    text(
      x = x + x_spacing + symb_sizes$x + x_spacing,
      y = y + symb_sizes$y,
      labels = valleg, cex = val_cex, adj = c(0, 0.5), col = fg
    )
  }


  return(invisible(NULL))
}

leg_typo <- function(pos = "topright",
                     val,
                     pal = "Inferno",
                     alpha = NULL,
                     title = "Legend Title",
                     title_cex = .8 * size,
                     val_cex = .6 * size,
                     col_na = "white",
                     no_data = FALSE,
                     no_data_txt = "No Data",
                     frame = FALSE,
                     frame_border = fg,
                     box_border = "#333333",
                     bg = "#f7f7f7",
                     fg = "#333333",
                     size = 1,
                     box_cex = c(1, 1),
                     return_bbox = FALSE,
                     adj = c(0, 0)) {
  # spacings
  x_spacing <- xinch(par("csi")) / 4
  y_spacing <- yinch(par("csi")) / 4

  # boxes sizes
  w_box <- box_cex[1] * size * x_spacing * 5
  h_box <- box_cex[2] * size * y_spacing * 5 * 2 / 3

  # Nb. boxes and values
  n_val <- n_box <- length(val)

  # box colors
  pal <- get_pal(pal, n_box, alpha = alpha)

  # title dimensions
  title_dim <- get_title_dim(title, title_cex)

  # boxes dimensions
  boxes_dim <- list(w = w_box, h = n_box * h_box + y_spacing * (n_box - 1))

  # label dimension
  labels_dim <- list(
    w = max(strwidth(val, units = "user", cex = val_cex, font = 1))
  )

  # label (+) box dim
  max_sizes <- pmax(
    strheight(val, units = "user", cex = val_cex, font = 1),
    rep(h_box, n_box)
  )

  # NA box and label dimensions
  if (isTRUE(no_data)) {
    na_box_dim <- list(w = w_box, h = h_box)
    na_label_dim <- list(
      w = strwidth(no_data_txt, units = "user", cex = val_cex, font = 1),
      h = max(strheight(no_data_txt, units = "user", cex = val_cex, font = 1), h_box)
    )
  } else {
    na_box_dim <- list(w = 0, h = 0)
    na_label_dim <- list(w = 0, h = 0)
    no_data_txt <- ""
  }

  # legend dimension
  legend_dim <- list(
    w = x_spacing +
      max(
        title_dim$w,
        boxes_dim$w + labels_dim$w + x_spacing,
        na_box_dim$w + na_label_dim$w + x_spacing
      ) +
      x_spacing,
    h = y_spacing +
      ifelse(title_dim$h != 0, title_dim$h + 2 * y_spacing * size, 0) +
      sum(max_sizes) + (n_box - 1) * y_spacing +
      ifelse(na_label_dim$h != 0, na_label_dim$h + y_spacing * size, 0) +
      y_spacing
  )

  # get legend coordinates
  legend_coords <- get_legend_coords(
    pos = pos, legend_dim = legend_dim,
    adj = adj, frame = frame,
    x_spacing = x_spacing,
    y_spacing = y_spacing
  )

  # return legend coordinates only
  if (return_bbox) {
    return(invisible(legend_coords))
  }

  # display frame
  plot_frame(
    frame = frame, legend_coords = legend_coords,
    bg = bg, frame_border = frame_border,
    x_spacing = x_spacing, y_spacing = y_spacing
  )

  # display title
  plot_title(
    title = title, title_cex = title_cex, title_dim = title_dim,
    fg = fg, legend_coords = legend_coords,
    x_spacing = x_spacing, y_spacing = y_spacing
  )

  # display boxes
  center <- rep(NA, n_val)
  center[1] <- legend_coords$top - y_spacing -
    ifelse(title_dim$h != 0, title_dim$h + 2 * y_spacing * size, 0) -
    max_sizes[1] / 2
  if (n_val > 1) {
    for (i in 2:n_val) {
      center[i] <- center[i - 1] - max_sizes[i - 1] / 2 - y_spacing - max_sizes[i] / 2
    }
  }
  left <- rep(legend_coords$left + x_spacing, n_box)
  right <- left + w_box
  top <- center + h_box / 2
  bottom <- top - h_box
  rect(
    xleft = left, ybottom = bottom, xright = right, ytop = top,
    col = pal, border = box_border, lwd = .7
  )

  # display labels
  x <- rep(legend_coords$left + x_spacing + w_box + x_spacing, n_val)
  y <- center
  text(x = x, y = y, labels = val, cex = val_cex, adj = c(0, 0.5), col = fg)

  if (isTRUE(no_data)) {
    # display na box
    left <- legend_coords$left + x_spacing
    right <- left + w_box
    bottom <- legend_coords$bottom + y_spacing + (na_label_dim$h - na_box_dim$h) / 2
    top <- bottom + h_box
    rect(
      xleft = left, ybottom = bottom, xright = right, ytop = top,
      col = col_na, border = box_border, lwd = .7
    )

    # display na label
    x <- legend_coords$left + x_spacing + w_box + x_spacing
    y <- bottom + (top - bottom) / 2
    text(x = x, y = y, labels = no_data_txt, cex = val_cex, adj = c(0, 0.5), col = fg)
  }
  return(invisible(NULL))
}

#' @title Compose a map legend
#' @description Compose a map legend with several elements.
#' The "type" argument defines the
#' legend type.
#' Please note that some arguments are available for all types of legend and
#' some others are only relevant for specific legend types.
#'
#' @md
#' @param leg legend object
#' @param type type of legend:
#' * **prop** for proportional symbols,
#' * **choro** for choropleth maps,
#' * **cont** for continuous maps (e.g. raster),
#' * **typo** for typology maps,
#' * **symb** for symbols maps,
#' * **prop_line** for proportional lines maps,
#' * **grad_line** for graduated lines maps,
#' * **histo** for histograms,
#' * **choro_point** for choropleth points maps,
#' * **choro_line** for choropleth lines maps,
#' * **choro_symb** for choropleth on symbols maps
#' * **typo_line** for typology lines maps.
#' @param val
#' vector of value(s) (for "prop" and "prop_line", at least c(min, max)
#' for "cont"),
#' vector of categories (for "symb", "typo", "typo_line"),
#' break labels (for "choro", "choro_point", "choro_line", "choro_symb",
#' and "grad_line"),
#' histogram parameters (for "histo").
#' @param pal a color palette name or a vector of colors
#' @param alpha opacity, in the range \[0,1\]
#' @param inches size of the largest symbol (radius for circles, half width
#' for squares) in inches
#' @param val_max maximum value corresponding to the largest symbol or line
#' @param border symbol border color(s)
#' @param symbol type of symbols, 'circle' or 'square'
#' @param self_adjust if TRUE values are self-adjusted to keep min, max and
#' intermediate rounded values
#' @param title title of the legend
#' @param val_rnd number of decimal places of the values in
#' the legend
#' @param val_dec decimal separator
#' @param val_big thousands separator
#' @param no_data if TRUE a "missing value" box is plotted
#' @param no_data_txt label for missing values
#' @param box_border border color of legend boxes
#' @param box_cex width and height size expansion for boxes, histogram or lines
#' @param col color of the symbols (for "prop") or color of the lines (for
#' "prop_line" and "grad_line")
#' @param lwd width(s) of the symbols borders (for "prop", "symb",
#' "choro_point", "choro_symb"),
#' width of the largest line (for "prop_line"), line width (for "choro_line"
#' and "typo_line"), vector of line widths (for "grad_line")
#' @param cex size(s) of the symbols
#' @param pch type(s) of the symbols (0:25)
#' @param col_na color for missing values
#' @param cex_na size of the symbols for missing values
#' @param pch_na type of the symbols for missing values
#' @param horiz if TRUE plot an horizontal legend
#' @return A list of legends parameters is returned.
#' @export
#' @examples
#' # minimal example
#' plot.new()
#' plot.window(xlim = c(0, 1), ylim = c(0, 1), asp = 1)
#' box()
#' leg_comp(type = "prop", val = c(10, 50, 100)) |>
#'   leg_comp(type = "typo", val = c("A", "B", "C")) |>
#'   leg_draw()
leg_comp <- function(leg,
                     type,
                     val,
                     pal = "Inferno",
                     alpha = NULL,
                     col = "tomato4",
                     inches = .3,
                     val_max = NULL,
                     symbol = "circle",
                     self_adjust = FALSE,
                     lwd = 0.7,
                     border = "#333333",
                     pch = 1:seq_along(val),
                     cex = rep(1, length(val)),
                     title = "Legend Title",
                     val_rnd = 0,
                     val_dec = ".",
                     val_big = "",
                     col_na = "white",
                     cex_na = 1,
                     pch_na = 4,
                     no_data = FALSE,
                     no_data_txt = "No Data",
                     box_border = "333333",
                     box_cex = c(1, 1),
                     horiz = FALSE) {
  res <- as.list(match.call()[-1])
  res <- lapply(res, eval)

  res <- clean_input(res, type = type)
  if (missing(leg)) {
    leg <- list()
  }
  leg$layers[[length(leg$layers) + 1]] <- res
  return(leg)
}


clean_input <- function(res, type) {
  res <- res[unlist(lapply(
    X = res,
    FUN = function(x) {
      !is.name(x)
    }
  ))]
  res$leg <- NULL
  res$type <- type
  res
}

expect_silent({
  plot.new()
  plot.window(xlim = c(0, 1), ylim = c(0, 1), asp = 1)
  box()
  leg_comp(type = "prop", val = c(10, 50, 100)) |>
    leg_comp(type = "typo", val = c("A", "B", "C")) |>
    leg_draw()
})

expect_silent({
  plot.new()
  plot.window(xlim = c(0, 1), ylim = c(0, 1), asp = 1)
  box()
  leg_comp(type = "prop", val = c(10, 50, 100)) |>
    leg_comp(type = "typo", val = c("A", "B", "C")) |>
    leg_draw(pos = NA)
}
)

expect_silent({
  plot.new()
  plot.window(xlim = c(0, 1), ylim = c(0, 1), asp = 1)
  box()
  leg_comp(type = "prop", val = c(10, 50, 100)) |>
    leg_comp(type = "typo", val = c("A", "B", "C")) |>
    leg_draw(pos = "topright")
}
)



expect_silent({
  plot.new()
  plot.window(xlim = c(0, 1), ylim = c(0, 1), asp = 1)
  box()
  leg_comp(type = "prop", val = c(10, 50, 100)) |>
    leg_comp(type = "prop", val = c(10, 50, 100)) |>
    leg_comp(type = "histo", val = hist(rnorm(150), plot = FALSE)) |>
    leg_draw(pos = "right")
}
)



expect_silent({
  plot.new()
  plot.window(xlim = c(0, 1), ylim = c(0, 1), asp = 1)
  box()
  leg_comp(type = "prop", val = c(10, 50, 100)) |>
    leg_comp(type = "typo", val = c("A", "B", "C")) |>
    leg_draw(pos = c(.5, .5))
}
)




expect_error({
  plot.new()
  plot.window(xlim = c(0, 1), ylim = c(0, 1), asp = 1)
  box()
  leg_comp(type = "prop", val = c(10, 50, 100)) |>
    leg_comp(type = "typo", val = c("A", "B", "C")) |>
    leg_draw(pos = "interactive")
}
)

leg_choro_point_h <- function(pos = "left",
                              val,
                              pal = "Inferno",
                              alpha = NULL,
                              symbol = "circle",
                              title = "Legend Title",
                              title_cex = .8 * size,
                              val_cex = .6 * size,
                              val_rnd = 0,
                              val_dec = ".",
                              val_big = "",
                              col_na = "white",
                              no_data = FALSE,
                              no_data_txt = "No Data",
                              frame = FALSE,
                              frame_border = fg,
                              border = "#333333",
                              bg = "#f7f7f7",
                              fg = "#333333",
                              size = 1,
                              cex = 1,
                              return_bbox = FALSE,
                              adj = c(0, 0)) {
  # spacings
  x_spacing <- xinch(par("csi")) / 4
  y_spacing <- yinch(par("csi")) / 4

  # boxes sizes
  w_box <- cex * size * x_spacing * 5 * 2 / 3
  h_box <- cex * size * y_spacing * 5 * 2 / 3


  # Nb. boxes and values
  n_val <- length(val)
  n_box <- n_val - 1

  # rounded and ordered values for the legend
  val <- get_val_rnd(val = val, val_rnd = val_rnd, val_dec = val_dec, val_big = val_big)

  # box colors
  pal <- get_pal(pal, n_box, alpha = alpha)

  # title dimensions
  title_dim <- get_title_dim(title, title_cex)

  # label dimension
  labels_dim <- list(
    w = strwidth(val[1], units = "user", cex = val_cex, font = 1) / 2 +
      strwidth(val[n_val], units = "user", cex = val_cex, font = 1) / 2 +
      n_box * w_box,
    h = max(strheight(val, units = "user", cex = val_cex, font = 1))
  )

  # NA box and label dimensions
  if (isTRUE(no_data)) {
    na_label_dim <- list(
      w = max(strwidth(no_data_txt, units = "user", cex = val_cex, font = 1), w_box),
      h = strheight(no_data_txt, units = "user", cex = val_cex, font = 1)
    )
  } else {
    na_label_dim <- list(w = 0, h = 0)
    no_data_txt <- ""
  }

  # legend dimension
  legend_dim <- list(
    w = x_spacing +
      max(
        title_dim$w,
        labels_dim$w + ifelse(na_label_dim$w != 0, na_label_dim$w + 2 * x_spacing * size, 0)
      ) +
      x_spacing,
    h = y_spacing +
      ifelse(title_dim$h != 0, title_dim$h + 2 * y_spacing * size, 0) +
      h_box +
      y_spacing +
      max(labels_dim$h, na_label_dim$h) +
      y_spacing
  )

  # get legend coordinates
  legend_coords <- get_legend_coords(
    pos = pos, legend_dim = legend_dim,
    adj = adj, frame = frame,
    x_spacing = x_spacing,
    y_spacing = y_spacing
  )

  # return legend coordinates only
  if (return_bbox) {
    return(invisible(legend_coords))
  }

  # display frame
  plot_frame(
    frame = frame, legend_coords = legend_coords,
    bg = bg, frame_border = frame_border,
    x_spacing = x_spacing, y_spacing = y_spacing
  )

  # display title
  plot_title(
    title = title, title_cex = title_cex, title_dim = title_dim,
    fg = fg, legend_coords = legend_coords,
    x_spacing = x_spacing, y_spacing = y_spacing
  )

  # display boxes
  top <- rep(
    legend_coords$top - x_spacing -
      ifelse(title_dim$h != 0, title_dim$h + 2 * y_spacing * size, 0),
    n_box
  )
  bottom <- top - h_box
  left <- rep(NA, n_box)
  x <- legend_coords$left + x_spacing + strwidth(val[1], units = "user", cex = val_cex, font = 1) / 2
  for (i in 1:n_box) {
    left[i] <- x + (i - 1) * w_box
  }
  right <- left + w_box

  if (symbol == "square") {
    rect(
      xleft = left, ybottom = bottom, xright = right, ytop = top,
      col = pal, border = border, lwd = .7
    )
  }

  if (symbol == "circle") {
    symbols(
      x = left + (right - left) / 2, y = bottom + (top - bottom) / 2,
      circles = (right - left) / 2, inches = FALSE, add = TRUE,
      bg = pal, fg = border, lwd = .7
    )
  }

  # display labels
  y <- rep(bottom[1] - y_spacing, n_val)
  x <- rep(x, n_val)
  for (i in 1:n_val) {
    x[i] <- x[1] + (i - 1) * w_box
  }
  text(x = x, y = y, labels = val, cex = val_cex, adj = c(0.5, 1), col = fg)


  if (isTRUE(no_data)) {
    # display na box
    bottom <- bottom[1]
    top <- top[1]
    center <- legend_coords$right - y_spacing - na_label_dim$w / 2
    if (symbol == "square") {
      rect(
        xleft = center - w_box / 2, ybottom = bottom,
        xright = center + w_box / 2, ytop = top,
        col = col_na, border = border, lwd = .7
      )
    }
    if (symbol == "circle") {
      symbols(
        x = center, y = bottom + (top - bottom) / 2,
        circles = (right[1] - left[1]) / 2, inches = FALSE, add = TRUE,
        bg = col_na, fg = border, lwd = .7
      )
    }

    # display na label
    text(
      x = center, y = y[1], labels = no_data_txt, cex = val_cex,
      adj = c(0.5, 1), col = fg
    )
  }


  return(invisible(NULL))
}

leg_choro_symb <- function(pos = "left",
                           val,
                           pal = "Inferno",
                           alpha = NULL,
                           pch = 21,
                           cex = 1,
                           lwd = .7,
                           title = "Legend Title",
                           title_cex = .8 * size,
                           val_cex = .6 * size,
                           val_rnd = 2,
                           val_dec = ".",
                           val_big = "",
                           col_na = "white",
                           no_data = FALSE,
                           no_data_txt = "No Data",
                           frame = FALSE,
                           frame_border = fg,
                           border = "#333333",
                           bg = "#f7f7f7",
                           fg = "#333333",
                           size = 1,
                           box_cex = c(1, 1),
                           return_bbox = FALSE,
                           adj = c(0, 0)) {
  # spacings
  x_spacing <- xinch(par("csi")) / 4
  y_spacing <- yinch(par("csi")) / 4

  # Nb. boxes and values
  n_val <- length(val)
  n_box <- n_val - 1

  # rounded and ordered values for the legend
  val <- rev(get_val_rnd(
    val = val, val_rnd = val_rnd, val_dec = val_dec,
    val_big = val_big
  ))

  # symbols attributes
  pch <- pch[[1]]
  cex <- cex[[1]]
  lwd <- lwd[[1]]
  border <- border[[1]]

  # symbol color
  col <- pbg <- rev(get_pal(pal, n_box, alpha = alpha))
  if (pch %in% 21:25) {
    col <- rep(border, n_box)
  }
  if (no_data) {
    col_na_bg <- col_na
    if (pch %in% 21:25) {
      col_na <- border
    }
  }

  # symbol sizes
  symb_sizes <- list(
    w =  strwidth("M", units = "user", cex = cex) * .9 * box_cex[1],
    h = strheight("M", units = "user", cex = cex) * .9 * box_cex[2]
  )

  # title dimensions
  title_dim <- get_title_dim(title, title_cex)

  # label dimension
  labels_dim <- list(
    w = max(strwidth(val, units = "user", cex = val_cex, font = 1))
  )

  # label dimension
  labels_dim <- list(
    w = max(strwidth(val, units = "user", cex = val_cex, font = 1)),
    h = strheight(val[1], units = "user", cex = val_cex, font = 1) / 2 +
      strheight(val[n_val], units = "user", cex = val_cex, font = 1) / 2 +
      n_box * symb_sizes$h
  )

  # NA box and label dimensions
  if (isTRUE(no_data)) {
    na_box_dim <- symb_sizes
    na_label_dim <- list(
      w = strwidth(no_data_txt, units = "user", cex = val_cex, font = 1),
      h = max(strheight(no_data_txt, units = "user", cex = val_cex, font = 1), na_box_dim$h)
    )
  } else {
    na_box_dim <- list(w = 0, h = 0)
    na_label_dim <- list(w = 0, h = 0)
    no_data_txt <- ""
  }

  legend_dim <- list(
    w = x_spacing +
      max(
        title_dim$w,
        symb_sizes$w + labels_dim$w + x_spacing,
        na_box_dim$w + na_label_dim$w + x_spacing
      ) +
      x_spacing,
    h = y_spacing +
      ifelse(title_dim$h != 0, title_dim$h + 2 * y_spacing * size, 0) +
      labels_dim$h +
      ifelse(na_label_dim$h != 0, na_label_dim$h + y_spacing * size, 0) +
      y_spacing
  )

  # get legend coordinates
  legend_coords <- get_legend_coords(
    pos = pos, legend_dim = legend_dim,
    adj = adj, frame = frame,
    x_spacing = x_spacing,
    y_spacing = y_spacing
  )

  # return legend coordinates only
  if (return_bbox) {
    return(invisible(legend_coords))
  }

  # display frame
  plot_frame(
    frame = frame, legend_coords = legend_coords,
    bg = bg, frame_border = frame_border,
    x_spacing = x_spacing, y_spacing = y_spacing
  )

  # display title
  plot_title(
    title = title, title_cex = title_cex, title_dim = title_dim,
    fg = fg, legend_coords = legend_coords,
    x_spacing = x_spacing, y_spacing = y_spacing
  )

  # display boxes
  left <- rep(legend_coords$left + x_spacing, n_box)
  right <- left + symb_sizes$w
  y <- legend_coords$top - y_spacing -
    ifelse(title_dim$h != 0, title_dim$h + 2 * y_spacing * size, 0) -
    strheight(val[1], units = "user", cex = val_cex, font = 1) / 2
  top <- rep(NA, n_box)
  for (i in 1:n_box) {
    top[i] <- y - (i - 1) * symb_sizes$h
  }
  bottom <- top - symb_sizes$h

  for (i in seq_len(n_val)) {
    points(
      x = left[i] + (right[i] - left[i]) / 2,
      y = bottom[i] + (top[i] - bottom[i]) / 2,
      col = col[i],
      pch = pch,
      cex = cex,
      bg = pbg[i],
      lwd = lwd
    )
  }
  # display labels
  x <- rep(legend_coords$left + x_spacing + symb_sizes$w + x_spacing, n_val)
  y <- rep(NA, n_val)
  top <- top[1]
  for (i in 1:n_val) {
    y[i] <- top - (i - 1) * symb_sizes$h
  }
  text(x = x, y = y, labels = val, cex = val_cex, adj = c(0, 0.5), col = fg)

  if (isTRUE(no_data)) {
    # display na box
    xna <- legend_coords$left + x_spacing + symb_sizes$w / 2
    yna <- legend_coords$bottom + y_spacing + na_label_dim$h / 2
    points(
      x = xna,
      y = yna,
      col = col_na,
      pch = pch,
      cex = cex,
      bg = col_na_bg,
      lwd = lwd
    )


    # display na label
    text(
      x = legend_coords$left + x_spacing + symb_sizes$w + x_spacing,
      y = yna,
      labels = no_data_txt,
      cex = val_cex,
      adj = c(0, 0.5),
      col = fg
    )
  }


  return(invisible(NULL))
}

#' @title Plot a single map legend
#' @description Plot different types of legend. The "type" argument defines the
#' legend type.
#' Please note that some arguments are available for all types of legend and
#' some others are only relevant for specific legend types (see Details).
#'
#' @md
#' @param type type of legend:
#' * **prop** for proportional symbols,
#' * **choro** for choropleth maps,
#' * **cont** for continuous maps (e.g. raster),
#' * **typo** for typology maps,
#' * **symb** for symbols maps,
#' * **prop_line** for proportional lines maps,
#' * **grad_line** for graduated lines maps,
#' * **histo** for histograms,
#' * **choro_point** for choropleth points maps,
#' * **choro_line** for choropleth lines maps,
#' * **choro_symb** for choropleth on symbols maps
#' * **typo_line** for typology lines maps.
#' @param val
#' vector of value(s) (for "prop" and "prop_line", at least c(min, max)
#' for "cont"),
#' vector of categories (for "symb", "typo", "typo_line"),
#' break labels (for "choro", "choro_point", "choro_line", "choro_symb",
#' and "grad_line"),
#' histogram parameters (for "histo").
#' @param pos position of the legend. It can be one of 'topleft', 'top',
#' 'topright', 'right', 'bottomright', 'bottom','bottomleft',
#' 'left', 'interactive' or a vector of two coordinates
#' in map units (c(x, y)).
#' @param pal a color palette name or a vector of colors
#' @param alpha opacity, in the range \[0,1\]
#' @param inches size of the largest symbol (radius for circles, half width
#' for squares) in inches
#' @param val_max maximum value corresponding to the largest symbol
#' @param border symbol border color(s)
#' @param symbol type of symbols, 'circle' or 'square'
#' @param self_adjust if TRUE values are self-adjusted to keep min, max and
#' intermediate rounded values
#' @param title title of the legend
#' @param title_cex size of the legend title
#' @param val_cex size of the values in the legend
#' @param val_rnd number of decimal places of the values in
#' the legend
#' @param val_dec decimal separator
#' @param val_big thousands separator
#' @param frame if TRUE the legend is plotted within a frame
#' @param no_data if TRUE a "missing value" box is plotted
#' @param no_data_txt label for missing values
#' @param bg background color of the legend
#' @param fg foreground color of the legend
#' @param box_border border color of legend boxes
#' @param box_cex width and height size expansion for boxes, histogram
#' circles, squares or lines
#' @param mar plot margins
#' @param return_bbox return only bounding box of the legend.
#' No legend is plotted.
#' @param col color of the symbols (for "prop") or color of the lines (for
#' "prop_line" and "grad_line")
#' @param lwd width(s) of the symbols borders (for "prop", "symb",
#' "choro_point", "choro_symb"),
#' width of the largest line (for "prop_line"), line width (for "choro_line"
#' and "typo_line"), vector of line widths (for "grad_line")
#' @param size size of the legend; 2 means two times bigger
#' @param cex size(s) of the symbols
#' @param pch type(s) of the symbols (0:25)
#' @param col_na color for missing values
#' @param cex_na size of the symbols for missing values
#' @param pch_na type of the symbols for missing values
#' @param horiz if TRUE plot an horizontal legend
#' @param adj adjust the postion of the legend in x and y directions.
#' @param frame_border border color of the frame
#' @import graphics
#' @return No value is returned, a legend is displayed.
#' @export
#' @details
#' Some arguments are available for all types of legend: `val`, `pos`, `title`,
#' `title_cex`, `val_cex`, `frame`, `bg`, `fg`, `size`, `adj`, `alpha`,
#' `return_bbox` and `mar`).
#'
#'
#' Relevant arguments for each specific legend types:
#' * `leg(type = "prop", val, inches, val_max, symbol, col, lwd, border, val_rnd, val_big, val_dec, self_adjust, horiz)`
#' * `leg(type = "choro", val, pal, val_rnd, val_big, val_dec, col_na, no_data, no_data_txt, box_border, box_cex, horiz)`
#' * `leg(type = "cont", val, pal, val_rnd, val_big, val_dec, col_na, no_data, no_data_txt, box_border, box_cex, horiz)`
#' * `leg(type = "typo", val, pal, col_na, no_data, no_data_txt, box_border, box_cex)`
#' * `leg(type = "symb", val, pal, pch, cex, lwd, pch_na, cex_na, col_na, no_data, no_data_txt)`
#' * `leg(type = "prop_line", val, col, lwd, val_rnd, val_big, val_dec)`
#' * `leg(type = "grad_line", val, col, lwd, val_rnd, val_big, val_dec)`
#' * `leg(type = "histo", val, pal, box_border, val_rnd, val_big, val_dec)`
#' * `leg(type = "choro_point", val, pal, symbol, border, cex, val_rnd, val_big, val_dec, col_na, no_data, no_data_txt, horiz)`
#' * `leg(type = "choro_line", val, pal, lwd, val_rnd, val_big, val_dec, col_na, no_data, no_data_txt)`
#' * `leg(type = "choro_symb", val, pal, pch, lwd, val_rnd, val_big, val_dec, col_na, no_data, no_data_txt)`
#' * `leg(type = "typo_line", val, pal, lwd, col_na, no_data, no_data_txt, box_cex)`

#' @examples
#' # minimal example
#' plot.new()
#' plot.window(xlim = c(0, 1), ylim = c(0, 1), asp = 1)
#' box()
#' leg(type = "prop", val = c(10, 50, 100), pos = "topleft")
#' leg(type = "choro", val = c(10, 20, 30, 40, 50), pos = "bottomleft")
#' leg(type = "typo", val = c("A", "B", "C"), pos = "top")
#' leg(type = "symb", val = c("A", "B", "C"), pos = "topright")
#' leg(type = "prop_line", val = c(5, 50, 100), pos = "bottom", lwd = 20)
#' leg(
#'   type = "grad_line", val = c(1, 4, 10, 15), pos = "bottomright",
#'   lwd = c(1, 5, 10)
#' )
#' plot.new()
#' plot.window(xlim = c(0, 1), ylim = c(0, 1), asp = 1)
#' leg(type = "prop", val = c(10, 50, 100), pos = "topleft", horiz = TRUE)
#' leg(type = "choro", val = c(10, 20, 30, 40, 50), pos = "left", horiz = TRUE)
#' leg(
#'   type = "cont", val = c(10, 20, 30, 40, 50), pos = "bottomleft",
#'   horiz = TRUE
#' )
#' leg(type = "choro_point", val = c(10, 20, 30, 40, 50), pos = "top")
#' leg(
#'   type = "choro_point", val = c(10, 20, 30, 40, 50), pos = "right",
#'   horiz = TRUE
#' )
#' leg(
#'   type = "cont", val = c(10, 20, 30, 40, 50), pos = "topright",
#'   horiz = FALSE
#' )
#' set.seed(46)
#' leg(
#'   type = "histo", val = hist(rnorm(1000), breaks = 5, plot = FALSE),
#'   pos = "bottomright"
#' )
#' box()
#'
#' plot.new()
#' plot.window(xlim = c(0, 1), ylim = c(0, 1), asp = 1)
#' leg(type = "choro_line", val = c(10, 20, 30, 40, 50), pos = "topleft")
#' leg(type = "typo_line", val = c("A", "B", "C"), pal = "Set 2", pos = "top")
#' leg(type = "choro_symb", val = c(10, 20, 30, 40, 50), pos = "topright")
#'
#'
#' # full example
#' plot.new()
#' plot.window(xlim = c(0, 1), ylim = c(0, 1))
#' leg(
#'   type = "prop",
#'   val = c(5, 100),
#'   pos = "top",
#'   inches = .4,
#'   symbol = "circle",
#'   col = "#940000",
#'   lwd = 1,
#'   border = "#9494ff",
#'   val_rnd = 1,
#'   self_adjust = TRUE,
#'   title = "Proportional Symbols",
#'   title_cex = 1,
#'   val_cex = .8,
#'   bg = "grey10",
#'   fg = "yellow",
#'   frame = TRUE
#' )
#'
#' plot.new()
#' plot.window(xlim = c(0, 1), ylim = c(0, 1))
#' leg(
#'   type = "choro",
#'   alpha = 1,
#'   val = c(10, 20, 30, 40, 50),
#'   pos = "top",
#'   pal = c("#7F000D", "#B56C6F", "#DBBABB", "#F1F1F1"),
#'   val_rnd = 2,
#'   col_na = "grey",
#'   no_data = TRUE,
#'   no_data_txt = "No data",
#'   box_border = "cornsilk",
#'   box_cex = c(2, 1),
#'   title = "Choropleth (sequential)"
#' )
#'
#' plot.new()
#' plot.window(xlim = c(0, 1), ylim = c(0, 1))
#' leg(
#'   type = "typo",
#'   val = c("A", "B", "C"),
#'   pos = "top",
#'   pal = "Dynamic",
#'   col_na = "grey",
#'   no_data = TRUE,
#'   no_data_txt = "No data",
#'   box_cex = c(1.2, 1),
#'   title = "Typology (categories)"
#' )
#'
#' plot.new()
#' plot.window(xlim = c(0, 1), ylim = c(0, 1))
#' leg(
#'   type = "symb",
#'   val = c("A", "B", "C"),
#'   pos = "top",
#'   pch = 21:23,
#'   cex = c(4, 4, 2),
#'   pal = "Inferno",
#'   lwd = 2,
#'   border = "red",
#'   col_na = "grey",
#'   pch_na = 3,
#'   cex_na = 1,
#'   no_data = TRUE,
#'   no_data_txt = "No data",
#'   title = "Symbols"
#' )
#'
#' plot.new()
#' plot.window(xlim = c(0, 1), ylim = c(0, 1))
#' leg(
#'   type = "cont",
#'   val = c(1, 2, 3, 4, 5),
#'   pos = "top",
#'   pal = "Inferno",
#'   alpha = .7,
#'   val_rnd = 2,
#'   horiz = TRUE,
#'   box_cex = c(2, 1),
#'   title = "Continuous"
#' )
#'
#' plot.new()
#' plot.window(xlim = c(0, 1), ylim = c(0, 1))
#' leg(
#'   type = "prop_line",
#'   val = c(54, 505, 1025),
#'   pos = "top",
#'   lwd = 15,
#'   col = "green",
#'   val_rnd = -1,
#'   box_cex = c(2, .5),
#'   title = "Proportional Lines",
#'   bg = "black",
#'   fg = "white",
#'   frame = TRUE
#' )
#'
#' plot.new()
#' plot.window(xlim = c(0, 1), ylim = c(0, 1))
#' leg(
#'   type = "grad_line",
#'   val = c(1.25, 4.07, 10.001, 15.071),
#'   pos = "top",
#'   lwd = c(1, 7, 15),
#'   col = "#C130ff",
#'   val_rnd = 3,
#'   box_cex = c(2, 1),
#'   title = "Graduated Lines"
#' )
#'
#' plot.new()
#' plot.window(xlim = c(0, 1), ylim = c(0, 1))
#' set.seed(46)
#' x <- rnorm(10000) * 1000
#' val <- hist(x, breaks = quantile(x, 0:10 / 10), plot = FALSE)
#' leg(
#'   type = "histo",
#'   alpha = 1,
#'   val = val,
#'   pos = "top",
#'   pal = "Teal",
#'   val_rnd = 0,
#'   val_big = " ",
#'   box_border = "cornsilk",
#'   box_cex = c(1, 2),
#'   title = "Histogram"
#' )
#'
#' plot.new()
#' plot.window(xlim = c(0, 1), ylim = c(0, 1))
#' leg(
#'   type = "choro_point",
#'   alpha = 1,
#'   val = c(10, 20, 30, 40, 50),
#'   pos = "top",
#'   pal = c("#7F000D", "#B56C6F", "#DBBABB", "#F1F1F1"),
#'   val_rnd = 2,
#'   col_na = "grey",
#'   no_data = TRUE,
#'   no_data_txt = "No data",
#'   border = "tomato4",
#'   cex = 1.5,
#'   title = "Choropleth (sequential)"
#' )
#'
#' plot.new()
#' plot.window(xlim = c(0, 1), ylim = c(0, 1))
#' leg(
#'   type = "choro_line",
#'   alpha = 1,
#'   val = c(10, 20, 30, 40, 50),
#'   pos = "top",
#'   pal = c("#7F000D", "#B56C6F", "#DBBABB", "#F1F1F1"),
#'   val_rnd = 1,
#'   lwd = 4,
#'   col_na = "grey",
#'   no_data = TRUE,
#'   no_data_txt = "No data",
#'   title = "Choropleth (sequential)"
#' )
#'
#' plot.new()
#' plot.window(xlim = c(0, 1), ylim = c(0, 1))
#' leg(
#'   type = "choro_symb",
#'   alpha = 1,
#'   val = c(10, 20, 30, 40, 50),
#'   pch = 23,
#'   pos = "top",
#'   pal = c("#7F000D", "#B56C6F", "#DBBABB", "#F1F1F1"),
#'   val_rnd = 1,
#'   lwd = 1,
#'   col_na = "grey",
#'   no_data = TRUE,
#'   no_data_txt = "No data",
#'   title = "Choropleth (sequential)"
#' )
#'
#' plot.new()
#' plot.window(xlim = c(0, 1), ylim = c(0, 1))
#' leg(
#'   type = "typo_line",
#'   val = c("A", "B", "C"),
#'   lwd = 3,
#'   pos = "top",
#'   pal = c("red", "yellow", "green"),
#'   col_na = "black",
#'   no_data = TRUE,
#'   no_data_txt = "No data",
#'   box_cex = c(2, 1),
#'   frame = TRUE,
#'   title = "Typology (categories)"
#' )
#'
#'
#' # Positions
#' plot.new()
#' plot.window(xlim = c(0, 1), ylim = c(0, 1), asp = 1)
#' leg(
#'   type = "prop", val = c(10, 60, 100), pos = "bottomleft", adj = c(0, 4),
#'   title = "adj = c(0, 4)", frame = TRUE
#' )
#' leg(
#'   type = "choro", val = c(10, 50, 100), pos = "bottomright",
#'   adj = c(0, 8), title = "adj = c(0, 8)", frame = TRUE
#' )
#' leg(
#'   type = "prop", val = c(10, 50, 100), pos = "topleft",
#'   adj = c(0, -8), title = "adj = c(0, -8)"
#' )
#' box()
#' mtext(
#'   text = "A text on 1 line", side = 1, adj = .01,
#'   line = -1, cex = 1
#' )
#' mtext(
#'   text = "A text\non 2 lines", side = 1, adj = .99,
#'   line = -1, cex = 1
#' )
#' mtext(
#'   text = "A large text on 1 line", side = 3, adj = .01,
#'   line = -2, cex = 2
#' )
leg <- function(type,
                val,
                pos = "left",
                pal = "Inferno",
                alpha = NULL,
                col = "tomato4",
                inches = .3,
                val_max = NULL,
                symbol = "circle",
                self_adjust = FALSE,
                lwd = 0.7,
                border = "#333333",
                pch = seq_along(val),
                cex = rep(1, length(val)),
                title = "Legend Title",
                title_cex = 0.8 * size,
                val_cex = 0.6 * size,
                val_rnd = 0,
                val_dec = ".",
                val_big = "",
                col_na = "white",
                cex_na = 1,
                pch_na = 4,
                no_data = FALSE,
                no_data_txt = "No Data",
                box_border = "#333333",
                box_cex = c(1, 1),
                horiz = FALSE,
                frame_border = fg,
                frame = FALSE,
                bg = "#f7f7f7",
                fg = "#333333",
                size = 1,
                return_bbox = FALSE,
                mar = par("mar"),
                adj = c(0, 0)) {
  # test pos and current plot
  if (any(is.na(pos))) {
    return(invisible(NULL))
  }

  leg_test_input(pos)

  # test at least 2 values
  if (any(startsWith(x = type, c("choro", "grad", "cont")))) {
    leg_test_nval(val)
  }

  op <- par(mar = mar, xpd = TRUE, no.readonly = TRUE)
  on.exit(par(op), add = TRUE)

  args <- as.list(match.call())
  args <- args[!names(args) %in% c("type", "horiz", "mar")]
  args <- args[-1]
  h <- ""
  if (horiz) {
    h <- "_h"
  }

  ffun <- get(paste0("leg_", type, h))

  if (length(pos) == 1 && pos == "interactive") {
    args$pos <- interleg()
  }

  if (!missing(val_dec)) {
    args$val_dec <- leg_test_val_dec(val_dec)
  }

  args <- lapply(args, eval, parent.frame(), parent.frame())
  x <- grDevices::recordGraphics(
    expr = do.call(what = ffun, args = args),
    list = list(args = args, ffun = ffun),
    env = getNamespace("maplegend")
  )
  return(invisible(x))
}

plot.new()
plot.window(xlim = c(0, 1),
            ylim = c(0, 1))
box()
vbox <- vector("list", 16)
vbox[[1]] <-
  leg(
    type = "prop",
    val = c(10, 50, 100),
    pos = "topleft",
    return_bbox = TRUE
  )
vbox[[2]] <- leg(
  type = "choro",
  val = c(10, 20, 30, 40, 50),
  pos = "bottomleft",
  return_bbox = TRUE
)
vbox[[3]] <- leg(
  type = "typo",
  val = c("A", "B", "C"),
  pos = "top",
  return_bbox = TRUE
)
vbox[[4]] <-
  leg(
    type = "symb",
    val = c("A", "B", "C"),
    pos = "topright",
    return_bbox = TRUE
  )
vbox[[5]] <-
  leg(
    type = "prop_line",
    val = c(5, 50, 100),
    pos = "bottom",
    lwd = 20,
    return_bbox = TRUE,
    box_cex = c(1, 1)
  )
vbox[[6]] <- leg(
  type = "grad_line",
  val = c(1, 4, 10, 15),
  pos = "bottomright",
  lwd = c(1, 5, 10),
  return_bbox = TRUE
)
vbox[[7]] <- leg(
  type = "cont",
  val = c(10, 20, 30, 40, 50),
  pos = "topright",
  return_bbox = TRUE
)
vbox[[8]] <-
  leg(
    type = "prop",
    val = c(10, 50, 100),
    pos = "topleft",
    horiz = TRUE,
    return_bbox = TRUE
  )
vbox[[9]] <-
  leg(
    type = "choro",
    val = c(10, 20, 30, 40, 50),
    pos = "left",
    horiz = TRUE,
    return_bbox = TRUE
  )
vbox[[10]] <-
  leg(
    type = "cont",
    val = c(10, 1000),
    pos = "bottomleft",
    horiz = TRUE,
    return_bbox = TRUE
  )

set.seed(46)
x <- round(rnorm(1000)*1000, 2)
xh <- hist(x, breaks = quantile(x, 0:10 /10), plot = F)
vbox[[11]] <-
  leg(
    type = "histo",
    val = xh,
    pos = "top",
    return_bbox = TRUE
  )

vbox[[12]] <-
  leg(
    type = "choro_point",
    val = 15:20,
    pos = "top",
    return_bbox = TRUE
  )
vbox[[13]] <-
  leg(
    type = "choro_point",
    val = 15:20,
    pos = "top", horiz = TRUE,
    return_bbox = TRUE
  )

vbox[[14]] <-
  leg(
    type = "choro_line",
    val = 15:20,
    pos = "top",
    return_bbox = TRUE
  )

vbox[[15]] <-
  leg(
    type = "typo_line",
    val = 15:20,
    pos = "top",
    return_bbox = TRUE
  )

vbox[[16]] <-
  leg(
    type = "choro_symb",
    val = 15:20,
    pos = "top",
    return_bbox = TRUE
  )
# saveRDS(vbox,
#         file = '/home/tim/Documents/pkg/maplegend/inst/tinytest/coords.rds')

vbox_ref <- readRDS('coords.rds')
expect_equal(vbox, vbox_ref)

get_val_rnd <- function(val, val_rnd, val_dec = getOption("OutDec"), val_big = "") {
  if (is.numeric(val)) {
    val <- round(val, val_rnd)
    if (val_rnd <= 0) {
      val_rnd <- 0
    }
    val <- format(
      x = val, scientific = FALSE, nsmall = val_rnd,
      decimal.mark = val_dec, big.mark = val_big,
      trim = TRUE
    )
  }
  return(val)
}

get_pal <- function(pal, nbreaks, alpha = 1) {
  if (length(pal) == 1) {
    if (pal %in% grDevices::hcl.pals()) {
      cols <- grDevices::hcl.colors(n = nbreaks, palette = pal, rev = TRUE)
    } else {
      cols <- rep(pal, nbreaks)
    }
  } else {
    cols <- pal[1:nbreaks]
  }
  if (!is.null(alpha)) {
    cols <- get_hex_pal(cols, alpha)
  }

  return(cols)
}

get_hex_pal <- function(pal, alpha) {
  pal <- grDevices::col2rgb(pal, alpha = FALSE)
  ffun <- function(x) {
    grDevices::rgb(pal[1, x],
      pal[2, x],
      pal[3, x],
      maxColorValue = 255
    )
  }
  paste0(sapply(1:ncol(pal), ffun), get_alpha(alpha))
}

get_alpha <- function(alpha) {
  if (alpha < 0) {
    alpha <- 0
  }
  if (alpha > 1) {
    alpha <- 1
  }
  sprintf("%02X", as.integer(255.999 * alpha))
}

get_title_dim <- function(title, title_cex) {
  h <- strheight(s = title, units = "user", cex = title_cex, font = 1)
  w <- strwidth(s = title, units = "user", cex = title_cex, font = 1)
  if (title == "" || is.na(title)) {
    w <- h <- 0
  }
  return(list(w = w, h = h))
}

# get the position of the legend
get_legend_coords <- function(pos, legend_dim, adj, frame, x_spacing, y_spacing) {
  if (is.numeric(pos) && length(pos) == 2) {
    xy <- pos
  } else {
    pu <- par("usr")
    if (isTRUE(frame)) {
      adj <- adj + switch(pos,
        bottomleft = c(1, 1),
        topleft = c(1, -1),
        left = c(1, 0),
        top = c(0, -1),
        bottom = c(0, 1),
        bottomright = c(-1, 1),
        right = c(-1, 0),
        topright = c(-1, -1),
        interactive = c(0, 0)
      )
    }
    extra <- adj * c(x_spacing, y_spacing)
    xy <- switch(pos,
      bottomleft = c(
        pu[1],
        pu[3] + legend_dim$h
      ),
      topleft = c(
        pu[1],
        pu[4]
      ),
      left = c(
        pu[1],
        pu[3] + (pu[4] - pu[3]) / 2 + legend_dim$h / 2
      ),
      top = c(
        pu[1] + (pu[2] - pu[1]) / 2 - legend_dim$w / 2,
        pu[4]
      ),
      bottom = c(
        pu[1] + (pu[2] - pu[1]) / 2 - legend_dim$w / 2,
        pu[3] + legend_dim$h
      ),
      bottomright = c(
        pu[2] - legend_dim$w,
        pu[3] + legend_dim$h
      ),
      right = c(
        pu[2] - legend_dim$w,
        pu[3] + (pu[4] - pu[3]) / 2 + legend_dim$h / 2
      ),
      topright = c(
        pu[2] - legend_dim$w,
        pu[4]
      )
    )
    xy <- xy + extra
  }
  return(list(
    right = xy[1] + legend_dim$w,
    left = xy[1],
    top = xy[2],
    bottom = xy[2] - legend_dim$h
  ))
}


plot_title <- function(title, title_cex, title_dim, fg, legend_coords,
                       x_spacing, y_spacing) {
  if (title_dim$h != 0) {
    x <- legend_coords$left + x_spacing
    y <- legend_coords$top - y_spacing - title_dim$h
    text(x = x, y = y, labels = title, cex = title_cex, adj = c(0, 0), col = fg)
  }
  return(invisible(NULL))
}


plot_frame <- function(frame, legend_coords, bg, frame_border,
                       x_spacing, y_spacing) {
  if (isTRUE(frame)) {
    rect(
      xleft = legend_coords$left,
      xright = legend_coords$right,
      ytop = legend_coords$top,
      ybottom = legend_coords$bottom,
      col = bg,
      border = frame_border,
      lwd = .7
    )
  }
}

interleg <- function() {
  if (interactive()) {
    message(paste0("Click on the map to choose the legend position."))
    x <- unlist(locator(1))
    message(paste0("Legend coordinates:\nc(", x[[1]], ", ", x[[2]], ")"))
    return(x)
  } else {
    stop('You cannot use "interactive" in a non-interactive R session.',
      call. = FALSE
    )
  }
}

leg_test_pos <- function(pos) {
  authorized_pos <-
    c(
      "bottomleft",
      "left",
      "topleft",
      "top",
      "bottom",
      "bottomright",
      "right",
      "topright",
      "interactive"
    )

  # stop if the position is not valid
  if (length(pos) == 1) {
    if (!pos %in% authorized_pos) {
      stop("This legend position is not allowed", call. = FALSE)
    }
  }
}

#' @importFrom grDevices dev.list
leg_test_cur_plot <- function() {
  if (is.null(dev.list())) {
    stop("You can only plot legends on an existing plot.", call. = FALSE)
  }
}

leg_test_input <- function(pos) {
  leg_test_pos(pos)
  leg_test_cur_plot()
}


leg_test_nval <- function(val) {
  if (length(val) < 2) {
    stop("You need to provide at least two values for 'val'.", call. = FALSE)
  }
}

leg_test_val_dec <- function(val_dec) {
  if (nchar(val_dec) > 1) {
    warning(paste0(
      "'val_dec' is more than one character wide; ",
      "only the first character is used."
    ), call. = FALSE)
    val_dec <- substr(val_dec, 1, 1)
  }
  if (nchar(val_dec) < 1) {
    warning(paste0(
      "'val_dec' is less than one character wide; ",
      "getOption('OutDec') is used."
    ), call. = FALSE)
    val_dec <- getOption("OutDec")
  }
  return(val_dec)
}


val_cont <- function(val, val_rnd, val_dec, val_big) {
  if (length(val) == 2) {
    val_ref_s <- pretty(val, n = 5)
    val_ref <- c(val_ref_s[val_ref_s > min(val) & val_ref_s < max(val)])
  } else if (length(val) > 2) {
    val_ref <- val
  }
  indices <- round((val_ref - min(val)) / (max(val) - min(val)) * 100, 0) + 1
  val_ref <- get_val_rnd(as.numeric(val_ref), val_rnd, val_dec, val_big)
  vval <- rep("", 101)
  vval[indices] <- val_ref
  vval
}

self_adjust_v <- function(var, inches, val_cex) {
  if (length(var) == 1) {
    return(var)
  }
  # get min & max
  val <- c(min(var), max(var))
  # factors
  b <- c(5, 2.5, 1)
  # min val
  min_s <- min(val)
  # max val
  max_s <- max(val)
  # get candidat values for the legend
  ndmax <- floor(log10(max_s))
  if (min_s < 1) {
    ndmin <- nchar(as.character(signif(min_s, digits = 0))) - 2
  } else {
    ndmin <- 1
  }
  i <- c(-ndmin:ndmax)
  v <- vector("numeric", 0)
  for (base in b) {
    v <- c(v, base * 10^i)
  }

  v <- c(max_s, min_s, v)
  v <- v[v >= min_s]
  v <- v[v <= max_s]
  v <- sort(unique(v))

  # circle sizes in map units for candidate values
  si <- yinch(sqrt(v * inches * inches / max(val)))

  # texte size labels in map units
  h <- max(strheight(val, units = "user", cex = val_cex, font = 1)) * 1.2

  # number of candidate values
  i <- length(si)

  # vector of displayed values
  a <- vector("logical", i)

  # The last one (max) is always displayed
  a[i] <- TRUE

  # go to next one
  i <- i - 1
  while (TRUE) {
    maxv <- si[length(si)] * 2
    # test space between two circles
    if (maxv - si[i] * 2 <= h) {
      # the space is too small
      a[i] <- FALSE
      # go to next value
      si <- si[-(length(si) - 1)]
    } else {
      # the space is not too small
      si <- si[-length(si)]
      # display ok
      a[i] <- TRUE
    }
    # increment
    i <- i - 1
    # last value
    if (i == 0) break
  }

  # If only one value is selected (max) select also the lower
  if (sum(a) <= 1) {
    a[1] <- TRUE
  }

  # if min value not selected, remove min selected value and replace
  # with min value
  if (a[1] == FALSE) {
    a[which(a)[1]] <- FALSE
    a[1] <- TRUE
  }

  return(v[a])
}

## internal function
graphics.off()
expect_error(maplegend:::leg_test_input("top"))
expect_equal(maplegend:::get_val_rnd(val = c(5.61, 6.23, 1012.86), val_rnd = 1, val_dec = ",", val_big = " "), c("5,6", "6,2","1 012,9"))
expect_warning(maplegend:::leg_test_val_dec(val_dec = ",,"))
expect_warning(maplegend:::leg_test_val_dec(val_dec = ""))

plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
     type = "n", xlab = NA, ylab = NA, axes = FALSE)
expect_error(maplegend:::leg_test_input("pop"))
expect_silent(maplegend:::leg_test_input("top"))
expect_null(leg(type = "prop", val = 1:5, pos = NA))
expect_equal(maplegend:::get_pal("red", 2), c("#FF0000FF", "#FF0000FF"))
expect_equal(maplegend:::get_alpha(-1), "00")
expect_equal(maplegend:::get_alpha(10), "FF")
expect_equal(maplegend:::get_title_dim("", title_cex = 2), list(w = 0, h = 0))

## prop
expect_silent(leg(type = "prop", pos = "topright", val = c(1, 5, 10), border = "white"))
expect_silent(leg(type = "prop", pos = "top", val = c(1, 5, 10), symbol = "square", col = "blue"))
expect_silent(leg(type = "prop", pos = "right", symbol = 'square', val = c(1, 5, 10), horiz = TRUE))
expect_silent(leg(type = "prop", pos = "left", symbol = 'square', val = c(1, 5, 10), self_adjust = TRUE))
expect_silent(leg(type = "prop", pos = c(.25,.75), val = c(1, 5, 10), self_adjust = TRUE, horiz = TRUE))
expect_silent(leg(type = "prop", pos = "topleft", val = c(1, 5, 10), val_max = 50))
expect_silent(leg(type = "prop", pos = "bottomleft", val = c(1, 5, 10), alpha = .5, frame = TRUE))
expect_silent(leg(type = "prop", pos = "bottomright", val = c(1, 5, 10), horiz = TRUE, frame = TRUE))
expect_silent(leg(type = "prop", pos = "bottom", val = 10))
expect_silent(leg(type = "prop", pos = c(.5,.5), val = c(1, 5, 10)))
expect_warning(leg(type = "prop", pos = c(.7, .7), val = c(1, 5, 10), val_dec = ""))

## choro
plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
     type = "n", xlab = NA, ylab = NA, axes = FALSE)
bks <- c(10, 20, 30, 40, 50)
expect_silent(leg(type = "choro", pos = "topleft", val = bks))
expect_silent(leg(type = "choro", pos = "topright", val = bks, horiz = TRUE))
expect_silent(leg(type = "choro", pos = "left", val = bks, frame = TRUE))
expect_silent(leg(type = "choro", pos = "right", val = bks, horiz = TRUE, frame = TRUE))
expect_silent(leg(type = "choro", pos = "bottomleft", val = bks, no_data = TRUE))
expect_silent(leg(type = "choro", pos = "bottomright", val = bks, horiz = TRUE, no_data = TRUE))
expect_silent(leg(type = "choro", pos = "top", val = bks, pal = hcl.colors(4, "Reds 2"), alpha = .5))
expect_silent(leg(type = "choro", pos = "bottom", val = bks, horiz = TRUE, pal = hcl.colors(4, "Reds 2"), alpha = .5))
expect_silent(leg(type = "choro", val = c(10, 50), pos = c(.5,.5)))
expect_silent(leg(type = "choro", val = c(10, 50), pos = c(.25,.75), horiz = TRUE))
expect_error(leg(type = "choro", val = 10, pos = "topright"))
expect_error(leg(type = "choro", val = 10, pos = "topright", horiz = TRUE))

## cont
plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
     type = "n", xlab = NA, ylab = NA, axes = FALSE)
bks <- c(10, 20, 30, 40, 50)
expect_silent(leg(type = "cont", pos = "topleft", val = bks))
expect_silent(leg(type = "cont", pos = "topright", val = bks, horiz = TRUE))
expect_silent(leg(type = "cont", pos = "left", val = bks, frame = TRUE))
expect_silent(leg(type = "cont", pos = "right", val = bks, horiz = TRUE, frame = TRUE))
expect_silent(leg(type = "cont", pos = "bottomleft", val = bks, no_data = TRUE, col_na = "blue"))
expect_silent(leg(type = "cont", pos = "bottomright", val = bks, horiz = TRUE, no_data = TRUE, col_na = "blue"))
expect_silent(leg(type = "cont", pos = "top", val = bks, pal = hcl.colors(4, "Reds 2"), alpha = .5))
expect_silent(leg(type = "cont", pos = "bottom", val = bks, horiz = TRUE, pal = hcl.colors(4, "Reds 2"), alpha = .5))
expect_silent(leg(type = "cont", val = c(10, 50), pos = c(.5,.5)))
expect_silent(leg(type = "cont", val = c(10, 50), pos = c(.25,.75), horiz = TRUE))
expect_error(leg(type = "cont", val = 10, pos = "topright"))
expect_error(leg(type = "cont", val = 10, pos = "topright", horiz = TRUE))

plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
     type = "n", xlab = NA, ylab = NA, axes = FALSE)
bks <- c(10,  50)
expect_silent(leg(type = "cont", pos = "topleft", val = bks))
expect_silent(leg(type = "cont", pos = "topright", val = bks, horiz = TRUE))
expect_silent(leg(type = "cont", pos = "left", val = bks, pal = c("red", "blue")))
expect_silent(leg(type = "cont", pos = "right", val = bks, horiz = TRUE, pal = c("red", "blue")))

## typo
plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
     type = "n", xlab = NA, ylab = NA, axes = FALSE)
mod <- c("mod 1", "mod 2 ", "mod 3")
expect_silent(leg(type = "typo", pos = "topleft", val = mod))
expect_silent(leg(type = "typo", pos = "left", val = mod, frame = TRUE))
expect_silent(leg(type = "typo", pos = "bottomleft", val = mod, no_data = TRUE))
expect_silent(leg(type = "typo", pos = "top", val = mod, pal = hcl.colors(4, "Reds 2"), alpha = .5))
expect_silent(leg(type = "typo", val = mod, pos = c(.5,.5)))
expect_silent(leg(type = "typo", val = 10, pos = "topright"))

## symb
plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
     type = "n", xlab = NA, ylab = NA, axes = FALSE)
mod <- c("mod 1", "mod 2 ", "mod 3")
expect_silent(leg(type = "symb", pos = "topleft", val = mod))
expect_silent(leg(type = "symb", pos = "left", val = mod, frame = TRUE))
expect_silent(leg(type = "symb", pos = "bottomleft", val = mod, no_data = TRUE))
expect_silent(leg(type = "symb", pos = "top", val = mod, pal = hcl.colors(4, "Reds 2"), alpha = .5))
expect_silent(leg(type = "symb", val = mod, pos = c(.5,.5)))
expect_silent(leg(type = "symb", val = 10, pos = "topright"))
expect_silent(leg(type = "symb", pos = "right", val = mod, pch = 21:23))
expect_silent(leg(type = "symb", pos = "bottomright", val = mod, pch = 22, cex = 2:5, lwd = 2:3))
expect_silent(leg(type = "symb", pos = "bottom", val = mod, no_data = TRUE))

## prop_line
plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
     type = "n", xlab = NA, ylab = NA, axes = FALSE)
expect_silent(leg(type = "prop_line", pos = "topright", val = c(1, 5, 10), lwd = 10))
expect_silent(leg(type = "prop_line", pos = "top", val = c(1, 5, 10), col = "blue", lwd = 10, frame = TRUE))
expect_silent(leg(type = "prop_line", pos = "topleft", val = c( 10), lwd = 10))
expect_silent(leg(type = "prop_line", pos = c(.5,.5), val = c(1, 5, 10), lwd = 5))

## grad_line
plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
     type = "n", xlab = NA, ylab = NA, axes = FALSE)
bks <- c(10, 20, 30, 40, 50)
expect_silent(leg(type = "grad_line", pos = "topleft", val = bks, lwd = c(1,2,4,8)))
expect_silent(leg(type = "grad_line", pos = "left", val = bks, frame = TRUE, lwd = c(1,2,4,8)))
expect_silent(leg(type = "grad_line", pos = "bottomleft", val = bks, lwd = c(1,2,4,8)))
expect_silent(leg(type = "grad_line", pos = "top", val = bks, alpha = .5, lwd = c(1,2,4,8)))
expect_silent(leg(type = "grad_line", val = c(.10, 50), pos = c(.5,.5)))
expect_error(leg(type = "grad_line", val = 10, pos = "topright"))

## histo
plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
     type = "n", xlab = NA, ylab = NA, axes = FALSE)
set.seed(46)
x <- round(rnorm(1000) * 1000, 2)
xh <- hist(x, breaks = quantile(x, 0:10 /10), plot = FALSE)
expect_silent(leg(type = "histo", val = xh, pos = "topleft", frame = TRUE))
expect_silent(leg(type = "histo", val = xh, pos = 'bottomright'    , frame = FALSE))

## choro_point
plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
     type = "n", xlab = NA, ylab = NA, axes = FALSE)
bks <- c(10, 20, 30, 40, 50)
expect_silent(leg(type = "choro_point", pos = "topleft", val = bks))
expect_silent(leg(type = "choro_point", pos = "topright", val = bks, horiz = TRUE))
expect_silent(leg(type = "choro_point", pos = "left", val = bks, frame = TRUE))
expect_silent(leg(type = "choro_point", pos = "right", val = bks, horiz = TRUE, frame = TRUE))
expect_silent(leg(type = "choro_point", pos = "bottomleft", val = bks, no_data = TRUE))
expect_silent(leg(type = "choro_point", pos = "bottomright", val = bks, horiz = TRUE, no_data = TRUE))
expect_silent(leg(type = "choro_point", pos = "top", val = bks, pal = hcl.colors(4, "Reds 2"), alpha = .5))
expect_silent(leg(type = "choro_point", pos = "bottom", val = bks, horiz = TRUE, pal = hcl.colors(4, "Reds 2"), alpha = .5))
expect_silent(leg(type = "choro_point", val = c(10, 50), pos = c(.5,.5)))
expect_silent(leg(type = "choro_point", val = c(10, 50), pos = c(.25,.75), horiz = TRUE))
expect_error(leg(type = "choro_point", val = 10, pos = "topright"))
expect_error(leg(type = "choro_point", val = 10, pos = "topright", horiz = TRUE))

plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
     type = "n", xlab = NA, ylab = NA, axes = FALSE)
expect_silent(leg(type = "choro_point", pos = "topleft", val = bks, symbol = "square"))
expect_silent(leg(type = "choro_point", pos = "topright", val = bks, horiz = TRUE, symbol = "square"))
expect_silent(leg(type = "choro_point", pos = "left", val = bks, frame = TRUE, symbol = "square"))
expect_silent(leg(type = "choro_point", pos = "right", val = bks, horiz = TRUE, frame = TRUE, symbol = "square"))
expect_silent(leg(type = "choro_point", pos = "bottomleft", val = bks, no_data = TRUE, symbol = "square"))
expect_silent(leg(type = "choro_point", pos = "bottomright", val = bks, horiz = TRUE, no_data = TRUE, symbol = "square"))
expect_silent(leg(type = "choro_point", pos = "top", val = bks, pal = hcl.colors(4, "Reds 2"), alpha = .5, symbol = "square"))
expect_silent(leg(type = "choro_point", pos = "bottom", val = bks, horiz = TRUE, pal = hcl.colors(4, "Reds 2"), alpha = .5, symbol = "square"))
expect_silent(leg(type = "choro_point", val = c(10, 50), pos = c(.5,.5), symbol = "square"))
expect_silent(leg(type = "choro_point", val = c(10, 50), pos = c(.25,.75), horiz = TRUE, symbol = "square"))

## choro_line
plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
     type = "n", xlab = NA, ylab = NA, axes = FALSE)
bks <- c(10, 20, 30, 40, 50)
expect_silent(leg(type = "choro_line", pos = "topleft", val = bks))
expect_silent(leg(type = "choro_line", pos = "left", val = bks, frame = TRUE))
expect_silent(leg(type = "choro_line", pos = "bottomleft", val = bks, no_data = TRUE))
expect_silent(leg(type = "choro_line", pos = "top", val = bks, pal = hcl.colors(4, "Reds 2"), alpha = .5))
expect_silent(leg(type = "choro_line", val = c(10, 50), pos = c(.5,.5)))
expect_error(leg(type = "choro_line", val = 10, pos = "topright"))
expect_error(leg(type = "choro_line", val = 10, pos = "topright", horiz = TRUE))


## choro_symb
plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
     type = "n", xlab = NA, ylab = NA, axes = FALSE)
bks <- c(10, 20, 30, 40, 50)
expect_silent(leg(type = "choro_symb", pos = "topleft", val = bks))
expect_silent(leg(type = "choro_symb", pos = "left", val = bks, frame = TRUE))
expect_silent(leg(type = "choro_symb", pos = "bottomleft", val = bks, no_data = TRUE))
expect_silent(leg(type = "choro_symb", pos = "top", val = bks, pal = hcl.colors(4, "Reds 2"), alpha = .5))
expect_silent(leg(type = "choro_symb", val = c(10, 50), pos = c(.5,.5)))
expect_error(leg(type = "choro_symb", val = 10, pos = "topright"))
expect_error(leg(type = "choro_symb", val = 10, pos = "topright", horiz = TRUE))


## typo_line
plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
     type = "n", xlab = NA, ylab = NA, axes = FALSE)
mod <- c("mod 1", "mod 2 ", "mod 3")
expect_silent(leg(type = "typo_line", pos = "topleft", val = mod))
expect_silent(leg(type = "typo_line", pos = "left", val = mod, frame = TRUE))
expect_silent(leg(type = "typo_line", pos = "bottomleft", val = mod, no_data = TRUE))
expect_silent(leg(type = "typo_line", pos = "top", val = mod, pal = hcl.colors(4, "Reds 2"), alpha = .5))
expect_silent(leg(type = "typo_line", val = mod, pos = c(.5,.5)))
expect_silent(leg(type = "typo_line", val = 10, pos = "topright"))

if (interactive()){
  ## internal function
  graphics.off()
  expect_error(maplegend:::leg_test_input("top"))
  expect_equal(maplegend:::get_val_rnd(val = c(5.61, 6.23, 1012.86), val_rnd = 1, val_dec = ",", val_big = " "), c("5,6", "6,2","1 012,9"))
  expect_warning(maplegend:::leg_test_val_dec(val_dec = ",,"))
  expect_warning(maplegend:::leg_test_val_dec(val_dec = ""))

  plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
       type = "n", xlab = NA, ylab = NA, axes = FALSE)
  expect_error(maplegend:::leg_test_input("pop"))
  expect_silent(maplegend:::leg_test_input("top"))
  expect_null(leg(type = "prop", val = 1:5, pos = NA))
  expect_equal(maplegend:::get_pal("red", 2), c("#FF0000FF", "#FF0000FF"))
  expect_equal(maplegend:::get_alpha(-1), "00")
  expect_equal(maplegend:::get_alpha(10), "FF")
  expect_equal(maplegend:::get_title_dim("", title_cex = 2), list(w = 0, h = 0))

  ## prop
  expect_silent(leg(type = "prop", pos = "topright", val = c(1, 5, 10), border = "white"))
  expect_silent(leg(type = "prop", pos = "top", val = c(1, 5, 10), symbol = "square", col = "blue"))
  expect_silent(leg(type = "prop", pos = "right", symbol = 'square', val = c(1, 5, 10), horiz = TRUE))
  expect_silent(leg(type = "prop", pos = "left", symbol = 'square', val = c(1, 5, 10), self_adjust = TRUE))
  expect_silent(leg(type = "prop", pos = c(.25,.75), val = c(1, 5, 10), self_adjust = TRUE, horiz = TRUE))
  expect_silent(leg(type = "prop", pos = "topleft", val = c(1, 5, 10), val_max = 50))
  expect_silent(leg(type = "prop", pos = "bottomleft", val = c(1, 5, 10), alpha = .5, frame = TRUE))
  expect_silent(leg(type = "prop", pos = "bottomright", val = c(1, 5, 10), horiz = TRUE, frame = TRUE))
  expect_silent(leg(type = "prop", pos = "bottom", val = 10))
  expect_silent(leg(type = "prop", pos = c(.5,.5), val = c(1, 5, 10)))
  expect_warning(leg(type = "prop", pos = c(.7, .7), val = c(1, 5, 10), val_dec = ""))

  ## choro
  plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
       type = "n", xlab = NA, ylab = NA, axes = FALSE)
  bks <- c(10, 20, 30, 40, 50)
  expect_silent(leg(type = "choro", pos = "topleft", val = bks))
  expect_silent(leg(type = "choro", pos = "topright", val = bks, horiz = TRUE))
  expect_silent(leg(type = "choro", pos = "left", val = bks, frame = TRUE))
  expect_silent(leg(type = "choro", pos = "right", val = bks, horiz = TRUE, frame = TRUE))
  expect_silent(leg(type = "choro", pos = "bottomleft", val = bks, no_data = TRUE))
  expect_silent(leg(type = "choro", pos = "bottomright", val = bks, horiz = TRUE, no_data = TRUE))
  expect_silent(leg(type = "choro", pos = "top", val = bks, pal = hcl.colors(4, "Reds 2"), alpha = .5))
  expect_silent(leg(type = "choro", pos = "bottom", val = bks, horiz = TRUE, pal = hcl.colors(4, "Reds 2"), alpha = .5))
  expect_silent(leg(type = "choro", val = c(10, 50), pos = c(.5,.5)))
  expect_silent(leg(type = "choro", val = c(10, 50), pos = c(.25,.75), horiz = TRUE))
  expect_error(leg(type = "choro", val = 10, pos = "topright"))
  expect_error(leg(type = "choro", val = 10, pos = "topright", horiz = TRUE))

  ## cont
  plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
       type = "n", xlab = NA, ylab = NA, axes = FALSE)
  bks <- c(10, 20, 30, 40, 50)
  expect_silent(leg(type = "cont", pos = "topleft", val = bks))
  expect_silent(leg(type = "cont", pos = "topright", val = bks, horiz = TRUE))
  expect_silent(leg(type = "cont", pos = "left", val = bks, frame = TRUE))
  expect_silent(leg(type = "cont", pos = "right", val = bks, horiz = TRUE, frame = TRUE))
  expect_silent(leg(type = "cont", pos = "bottomleft", val = bks, no_data = TRUE, col_na = "blue"))
  expect_silent(leg(type = "cont", pos = "bottomright", val = bks, horiz = TRUE, no_data = TRUE, col_na = "blue"))
  expect_silent(leg(type = "cont", pos = "top", val = bks, pal = hcl.colors(4, "Reds 2"), alpha = .5))
  expect_silent(leg(type = "cont", pos = "bottom", val = bks, horiz = TRUE, pal = hcl.colors(4, "Reds 2"), alpha = .5))
  expect_silent(leg(type = "cont", val = c(10, 50), pos = c(.5,.5)))
  expect_silent(leg(type = "cont", val = c(10, 50), pos = c(.25,.75), horiz = TRUE))
  expect_error(leg(type = "cont", val = 10, pos = "topright"))
  expect_error(leg(type = "cont", val = 10, pos = "topright", horiz = TRUE))

  plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
       type = "n", xlab = NA, ylab = NA, axes = FALSE)
  bks <- c(10,  50)
  expect_silent(leg(type = "cont", pos = "topleft", val = bks))
  expect_silent(leg(type = "cont", pos = "topright", val = bks, horiz = TRUE))
  expect_silent(leg(type = "cont", pos = "left", val = bks, pal = c("red", "blue")))
  expect_silent(leg(type = "cont", pos = "right", val = bks, horiz = TRUE, pal = c("red", "blue")))

  ## typo
  plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
       type = "n", xlab = NA, ylab = NA, axes = FALSE)
  mod <- c("mod 1", "mod 2 ", "mod 3")
  expect_silent(leg(type = "typo", pos = "topleft", val = mod))
  expect_silent(leg(type = "typo", pos = "left", val = mod, frame = TRUE))
  expect_silent(leg(type = "typo", pos = "bottomleft", val = mod, no_data = TRUE))
  expect_silent(leg(type = "typo", pos = "top", val = mod, pal = hcl.colors(4, "Reds 2"), alpha = .5))
  expect_silent(leg(type = "typo", val = mod, pos = c(.5,.5)))
  expect_silent(leg(type = "typo", val = 10, pos = "topright"))

  ## symb
  plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
       type = "n", xlab = NA, ylab = NA, axes = FALSE)
  mod <- c("mod 1", "mod 2 ", "mod 3")
  expect_silent(leg(type = "symb", pos = "topleft", val = mod))
  expect_silent(leg(type = "symb", pos = "left", val = mod, frame = TRUE))
  expect_silent(leg(type = "symb", pos = "bottomleft", val = mod, no_data = TRUE))
  expect_silent(leg(type = "symb", pos = "top", val = mod, pal = hcl.colors(4, "Reds 2"), alpha = .5))
  expect_silent(leg(type = "symb", val = mod, pos = c(.5,.5)))
  expect_silent(leg(type = "symb", val = 10, pos = "topright"))
  expect_silent(leg(type = "symb", pos = "right", val = mod, pch = 21:23))
  expect_silent(leg(type = "symb", pos = "bottomright", val = mod, pch = 22, cex = 2:5, lwd = 2:3))
  expect_silent(leg(type = "symb", pos = "bottom", val = mod, no_data = TRUE))

  ## prop_line
  plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
       type = "n", xlab = NA, ylab = NA, axes = FALSE)
  expect_silent(leg(type = "prop_line", pos = "topright", val = c(1, 5, 10), lwd = 10))
  expect_silent(leg(type = "prop_line", pos = "top", val = c(1, 5, 10), col = "blue", lwd = 10, frame = TRUE))
  expect_silent(leg(type = "prop_line", pos = "topleft", val = c( 10), lwd = 10))
  expect_silent(leg(type = "prop_line", pos = c(.5,.5), val = c(1, 5, 10), lwd = 5))

  ## grad_line
  plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
       type = "n", xlab = NA, ylab = NA, axes = FALSE)
  bks <- c(10, 20, 30, 40, 50)
  expect_silent(leg(type = "grad_line", pos = "topleft", val = bks, lwd = c(1,2,4,8)))
  expect_silent(leg(type = "grad_line", pos = "left", val = bks, frame = TRUE, lwd = c(1,2,4,8)))
  expect_silent(leg(type = "grad_line", pos = "bottomleft", val = bks, lwd = c(1,2,4,8)))
  expect_silent(leg(type = "grad_line", pos = "top", val = bks, alpha = .5, lwd = c(1,2,4,8)))
  expect_silent(leg(type = "grad_line", val = c(.10, 50), pos = c(.5,.5)))
  expect_error(leg(type = "grad_line", val = 10, pos = "topright"))

  ## histo
  plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
       type = "n", xlab = NA, ylab = NA, axes = FALSE)
  set.seed(46)
  x <- round(rnorm(1000) * 1000, 2)
  xh <- hist(x, breaks = quantile(x, 0:10 /10), plot = FALSE)
  expect_silent(leg(type = "histo", val = xh, pos = "topleft", frame = TRUE))
  expect_silent(leg(type = "histo", val = xh, pos = 'bottomright'    , frame = FALSE))

  ## choro_point
  plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
       type = "n", xlab = NA, ylab = NA, axes = FALSE)
  bks <- c(10, 20, 30, 40, 50)
  expect_silent(leg(type = "choro_point", pos = "topleft", val = bks))
  expect_silent(leg(type = "choro_point", pos = "topright", val = bks, horiz = TRUE))
  expect_silent(leg(type = "choro_point", pos = "left", val = bks, frame = TRUE))
  expect_silent(leg(type = "choro_point", pos = "right", val = bks, horiz = TRUE, frame = TRUE))
  expect_silent(leg(type = "choro_point", pos = "bottomleft", val = bks, no_data = TRUE))
  expect_silent(leg(type = "choro_point", pos = "bottomright", val = bks, horiz = TRUE, no_data = TRUE))
  expect_silent(leg(type = "choro_point", pos = "top", val = bks, pal = hcl.colors(4, "Reds 2"), alpha = .5))
  expect_silent(leg(type = "choro_point", pos = "bottom", val = bks, horiz = TRUE, pal = hcl.colors(4, "Reds 2"), alpha = .5))
  expect_silent(leg(type = "choro_point", val = c(10, 50), pos = c(.5,.5)))
  expect_silent(leg(type = "choro_point", val = c(10, 50), pos = c(.25,.75), horiz = TRUE))
  expect_error(leg(type = "choro_point", val = 10, pos = "topright"))
  expect_error(leg(type = "choro_point", val = 10, pos = "topright", horiz = TRUE))

  plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
       type = "n", xlab = NA, ylab = NA, axes = FALSE)
  expect_silent(leg(type = "choro_point", pos = "topleft", val = bks, symbol = "square"))
  expect_silent(leg(type = "choro_point", pos = "topright", val = bks, horiz = TRUE, symbol = "square"))
  expect_silent(leg(type = "choro_point", pos = "left", val = bks, frame = TRUE, symbol = "square"))
  expect_silent(leg(type = "choro_point", pos = "right", val = bks, horiz = TRUE, frame = TRUE, symbol = "square"))
  expect_silent(leg(type = "choro_point", pos = "bottomleft", val = bks, no_data = TRUE, symbol = "square"))
  expect_silent(leg(type = "choro_point", pos = "bottomright", val = bks, horiz = TRUE, no_data = TRUE, symbol = "square"))
  expect_silent(leg(type = "choro_point", pos = "top", val = bks, pal = hcl.colors(4, "Reds 2"), alpha = .5, symbol = "square"))
  expect_silent(leg(type = "choro_point", pos = "bottom", val = bks, horiz = TRUE, pal = hcl.colors(4, "Reds 2"), alpha = .5, symbol = "square"))
  expect_silent(leg(type = "choro_point", val = c(10, 50), pos = c(.5,.5), symbol = "square"))
  expect_silent(leg(type = "choro_point", val = c(10, 50), pos = c(.25,.75), horiz = TRUE, symbol = "square"))

  ## choro_line
  plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
       type = "n", xlab = NA, ylab = NA, axes = FALSE)
  bks <- c(10, 20, 30, 40, 50)
  expect_silent(leg(type = "choro_line", pos = "topleft", val = bks))
  expect_silent(leg(type = "choro_line", pos = "left", val = bks, frame = TRUE))
  expect_silent(leg(type = "choro_line", pos = "bottomleft", val = bks, no_data = TRUE))
  expect_silent(leg(type = "choro_line", pos = "top", val = bks, pal = hcl.colors(4, "Reds 2"), alpha = .5))
  expect_silent(leg(type = "choro_line", val = c(10, 50), pos = c(.5,.5)))
  expect_error(leg(type = "choro_line", val = 10, pos = "topright"))
  expect_error(leg(type = "choro_line", val = 10, pos = "topright", horiz = TRUE))


  ## choro_symb
  plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
       type = "n", xlab = NA, ylab = NA, axes = FALSE)
  bks <- c(10, 20, 30, 40, 50)
  expect_silent(leg(type = "choro_symb", pos = "topleft", val = bks))
  expect_silent(leg(type = "choro_symb", pos = "left", val = bks, frame = TRUE))
  expect_silent(leg(type = "choro_symb", pos = "bottomleft", val = bks, no_data = TRUE))
  expect_silent(leg(type = "choro_symb", pos = "top", val = bks, pal = hcl.colors(4, "Reds 2"), alpha = .5))
  expect_silent(leg(type = "choro_symb", val = c(10, 50), pos = c(.5,.5)))
  expect_error(leg(type = "choro_symb", val = 10, pos = "topright"))
  expect_error(leg(type = "choro_symb", val = 10, pos = "topright", horiz = TRUE))


  ## typo_line
  plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
       type = "n", xlab = NA, ylab = NA, axes = FALSE)
  mod <- c("mod 1", "mod 2 ", "mod 3")
  expect_silent(leg(type = "typo_line", pos = "topleft", val = mod))
  expect_silent(leg(type = "typo_line", pos = "left", val = mod, frame = TRUE))
  expect_silent(leg(type = "typo_line", pos = "bottomleft", val = mod, no_data = TRUE))
  expect_silent(leg(type = "typo_line", pos = "top", val = mod, pal = hcl.colors(4, "Reds 2"), alpha = .5))
  expect_silent(leg(type = "typo_line", val = mod, pos = c(.5,.5)))
  expect_silent(leg(type = "typo_line", val = 10, pos = "topright"))
}

## internal function
graphics.off()
expect_error(maplegend:::leg_test_input("top"))
expect_equal(maplegend:::get_val_rnd(val = c(5.61, 6.23, 1012.86), val_rnd = 1, val_dec = ",", val_big = " "), c("5,6", "6,2","1 012,9"))
expect_warning(maplegend:::get_val_rnd(val = c(5.61, 6.23, 1012.86), val_rnd = 1, val_dec = ",,"))
expect_warning(maplegend:::get_val_rnd(val = c(5.61, 6.23, 1012.86), val_rnd = 1, val_dec = ""))

plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
     type = "n", xlab = NA, ylab = NA, axes = FALSE)
expect_error(maplegend:::leg_test_input("pop"))
expect_silent(maplegend:::leg_test_input("top"))
expect_null(leg(type = "prop", val = 1:5, pos = NA))
expect_equal(maplegend:::get_pal("red", 2), c("#FF0000FF", "#FF0000FF"))
expect_equal(maplegend:::get_alpha(-1), "00")
expect_equal(maplegend:::get_alpha(10), "FF")
expect_equal(maplegend:::get_title_dim("", title_cex = 2), list(w = 0, h = 0))


## prop
plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
     type = "n", xlab = NA, ylab = NA, axes = FALSE)
expect_silent(leg(type = "prop", pos = "topright", val = c(1, 5, 10), border = "white"))
expect_silent(leg(type = "prop", pos = "top", val = c(1, 5, 10), symbol = "square", col = "blue"))
expect_silent(leg(type = "prop", pos = "right", symbol = 'square', val = c(1, 5, 10), horiz = TRUE))
expect_silent(leg(type = "prop", pos = "left", symbol = 'square', val = c(1, 5, 10), self_adjust = TRUE))
expect_silent(leg(type = "prop", pos = c(.25,.75), val = c(1, 5, 10), self_adjust = TRUE, horiz = TRUE))
expect_silent(leg(type = "prop", pos = "topleft", val = c(1, 5, 10), val_max = 50))
expect_silent(leg(type = "prop", pos = "bottomleft", val = c(1, 5, 10), alpha = .5, frame = TRUE))
expect_silent(leg(type = "prop", pos = "bottomright", val = c(1, 5, 10), horiz = TRUE, frame = TRUE))
expect_silent(leg(type = "prop", pos = "bottom", val = 10))
expect_silent(leg(type = "prop", pos = c(.5,.5), val = c(1, 5, 10)))

## choro
plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
     type = "n", xlab = NA, ylab = NA, axes = FALSE)
bks <- c(10, 20, 30, 40, 50)
expect_silent(leg(type = "choro", pos = "topleft", val = bks))
expect_silent(leg(type = "choro", pos = "topright", val = bks, horiz = TRUE))
expect_silent(leg(type = "choro", pos = "left", val = bks, frame = TRUE))
expect_silent(leg(type = "choro", pos = "right", val = bks, horiz = TRUE, frame = TRUE))
expect_silent(leg(type = "choro", pos = "bottomleft", val = bks, no_data = TRUE))
expect_silent(leg(type = "choro", pos = "bottomright", val = bks, horiz = TRUE, no_data = TRUE))
expect_silent(leg(type = "choro", pos = "top", val = bks, pal = hcl.colors(4, "Reds 2"), alpha = .5))
expect_silent(leg(type = "choro", pos = "bottom", val = bks, horiz = TRUE, pal = hcl.colors(4, "Reds 2"), alpha = .5))
expect_silent(leg(type = "choro", val = c(10, 50), pos = c(.5,.5)))
expect_silent(leg(type = "choro", val = c(10, 50), pos = c(.25,.75), horiz = TRUE))
expect_error(leg(type = "choro", val = 10, pos = "topright"))
expect_error(leg(type = "choro", val = 10, pos = "topright", horiz = TRUE))

## cont
graphics.off()
plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
     type = "n", xlab = NA, ylab = NA, axes = FALSE)
bks <- c(10, 20, 30, 40, 50)
expect_silent(leg(type = "cont", pos = "topleft", val = bks))
expect_silent(leg(type = "cont", pos = "topright", val = bks, horiz = TRUE))
expect_silent(leg(type = "cont", pos = "left", val = bks, frame = TRUE))
expect_silent(leg(type = "cont", pos = "right", val = bks, horiz = TRUE, frame = TRUE))
expect_silent(leg(type = "cont", pos = "bottomleft", val = bks, no_data = TRUE, col_na = "blue"))
expect_silent(leg(type = "cont", pos = "bottomright", val = bks, horiz = TRUE, no_data = TRUE, col_na = "blue"))
expect_silent(leg(type = "cont", pos = "top", val = bks, pal = hcl.colors(4, "Reds 2"), alpha = .5))
expect_silent(leg(type = "cont", pos = "bottom", val = bks, horiz = TRUE, pal = hcl.colors(4, "Reds 2"), alpha = .5))
expect_silent(leg(type = "cont", val = c(10, 50), pos = c(.5,.5)))
expect_silent(leg(type = "cont", val = c(10, 50), pos = c(.25,.75), horiz = TRUE))
expect_error(leg(type = "cont", val = 10, pos = "topright"))
expect_error(leg(type = "cont", val = 10, pos = "topright", horiz = TRUE))

graphics.off()
plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
     type = "n", xlab = NA, ylab = NA, axes = FALSE)
bks <- c(10,  50)
expect_silent(leg(type = "cont", pos = "topleft", val = bks))
expect_silent(leg(type = "cont", pos = "topright", val = bks, horiz = TRUE))
expect_silent(leg(type = "cont", pos = "left", val = bks, pal = c("red", "blue")))
expect_silent(leg(type = "cont", pos = "right", val = bks, horiz = TRUE, pal = c("red", "blue")))

## typo
graphics.off()
plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
     type = "n", xlab = NA, ylab = NA, axes = FALSE)
mod <- c("mod 1", "mod 2 ", "mod 3")
expect_silent(leg(type = "typo", pos = "topleft", val = mod))
expect_silent(leg(type = "typo", pos = "left", val = mod, frame = TRUE))
expect_silent(leg(type = "typo", pos = "bottomleft", val = mod, no_data = TRUE))
expect_silent(leg(type = "typo", pos = "top", val = mod, pal = hcl.colors(4, "Reds 2"), alpha = .5))
expect_silent(leg(type = "typo", val = mod, pos = c(.5,.5)))
expect_silent(leg(type = "typo", val = 10, pos = "topright"))

## symb
graphics.off()
plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
     type = "n", xlab = NA, ylab = NA, axes = FALSE)
mod <- c("mod 1", "mod 2 ", "mod 3")
expect_silent(leg(type = "symb", pos = "topleft", val = mod))
expect_silent(leg(type = "symb", pos = "left", val = mod, frame = TRUE))
expect_silent(leg(type = "symb", pos = "bottomleft", val = mod, no_data = TRUE))
expect_silent(leg(type = "symb", pos = "top", val = mod, pal = hcl.colors(4, "Reds 2"), alpha = .5))
expect_silent(leg(type = "symb", val = mod, pos = c(.5,.5)))
expect_silent(leg(type = "symb", val = 10, pos = "topright"))
expect_silent(leg(type = "symb", pos = "right", val = mod, pch = 21:23))
expect_silent(leg(type = "symb", pos = "bottomright", val = mod, pch = 22, cex = 2:5, lwd = 2:3))
expect_silent(leg(type = "symb", pos = "bottom", val = mod, no_data = TRUE))

## prop_line
graphics.off()
plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
     type = "n", xlab = NA, ylab = NA, axes = FALSE)
expect_silent(leg(type = "prop_line", pos = "topright", val = c(1, 5, 10), lwd = 10))
expect_silent(leg(type = "prop_line", pos = "top", val = c(1, 5, 10), col = "blue", lwd = 10, frame = TRUE))
expect_silent(leg(type = "prop_line", pos = "topleft", val = c( 10), lwd = 10))
expect_silent(leg(type = "prop_line", pos = c(.5,.5), val = c(1, 5, 10), lwd = 5))

## grad_line
graphics.off()
plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
     type = "n", xlab = NA, ylab = NA, axes = FALSE)
bks <- c(10, 20, 30, 40, 50)
expect_silent(leg(type = "grad_line", pos = "topleft", val = bks, lwd = c(1,2,4,8)))
expect_silent(leg(type = "grad_line", pos = "left", val = bks, frame = TRUE, lwd = c(1,2,4,8)))
expect_silent(leg(type = "grad_line", pos = "bottomleft", val = bks, lwd = c(1,2,4,8)))
expect_silent(leg(type = "grad_line", pos = "top", val = bks, alpha = .5, lwd = c(1,2,4,8)))
expect_silent(leg(type = "grad_line", val = c(.10, 50), pos = c(.5,.5)))
expect_error(leg(type = "grad_line", val = 10, pos = "topright"), class = "error")

## histo
graphics.off()
plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
     type = "n", xlab = NA, ylab = NA, axes = FALSE)
set.seed(46)
x <- round(rnorm(1000) * 1000, 2)
xh <- hist(x, breaks = quantile(x, 0:10 /10), plot = FALSE)
expect_silent(leg(type = "histo", val = xh, pos = "topleft", frame = TRUE))
expect_silent(leg(type = "histo", val = xh, pos = 'bottomright'    , frame = FALSE))

## choro_point
graphics.off()
plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
     type = "n", xlab = NA, ylab = NA, axes = FALSE)
bks <- c(10, 20, 30, 40, 50)
expect_silent(leg(type = "choro_point", pos = "topleft", val = bks))
expect_silent(leg(type = "choro_point", pos = "topright", val = bks, horiz = TRUE))
expect_silent(leg(type = "choro_point", pos = "left", val = bks, frame = TRUE))
expect_silent(leg(type = "choro_point", pos = "right", val = bks, horiz = TRUE, frame = TRUE))
expect_silent(leg(type = "choro_point", pos = "bottomleft", val = bks, no_data = TRUE))
expect_silent(leg(type = "choro_point", pos = "bottomright", val = bks, horiz = TRUE, no_data = TRUE))
expect_silent(leg(type = "choro_point", pos = "top", val = bks, pal = hcl.colors(4, "Reds 2"), alpha = .5))
expect_silent(leg(type = "choro_point", pos = "bottom", val = bks, horiz = TRUE, pal = hcl.colors(4, "Reds 2"), alpha = .5))
expect_silent(leg(type = "choro_point", val = c(10, 50), pos = c(.5,.5)))
expect_silent(leg(type = "choro_point", val = c(10, 50), pos = c(.25,.75), horiz = TRUE))
expect_error(leg(type = "choro_point", val = 10, pos = "topright"), class = "error")
expect_error(leg(type = "choro_point", val = 10, pos = "topright", horiz = TRUE), class = "error")
graphics.off()
plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
     type = "n", xlab = NA, ylab = NA, axes = FALSE)
expect_silent(leg(type = "choro_point", pos = "topleft", val = bks, symbol = "square"))
expect_silent(leg(type = "choro_point", pos = "topright", val = bks, horiz = TRUE, symbol = "square"))
expect_silent(leg(type = "choro_point", pos = "left", val = bks, frame = TRUE, symbol = "square"))
expect_silent(leg(type = "choro_point", pos = "right", val = bks, horiz = TRUE, frame = TRUE, symbol = "square"))
expect_silent(leg(type = "choro_point", pos = "bottomleft", val = bks, no_data = TRUE, symbol = "square"))
expect_silent(leg(type = "choro_point", pos = "bottomright", val = bks, horiz = TRUE, no_data = TRUE, symbol = "square"))
expect_silent(leg(type = "choro_point", pos = "top", val = bks, pal = hcl.colors(4, "Reds 2"), alpha = .5, symbol = "square"))
expect_silent(leg(type = "choro_point", pos = "bottom", val = bks, horiz = TRUE, pal = hcl.colors(4, "Reds 2"), alpha = .5, symbol = "square"))
expect_silent(leg(type = "choro_point", val = c(10, 50), pos = c(.5,.5), symbol = "square"))
expect_silent(leg(type = "choro_point", val = c(10, 50), pos = c(.25,.75), horiz = TRUE, symbol = "square"))

## choro_line
graphics.off()
plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
     type = "n", xlab = NA, ylab = NA, axes = FALSE)
bks <- c(10, 20, 30, 40, 50)
expect_silent(leg(type = "choro_line", pos = "topleft", val = bks))
expect_silent(leg(type = "choro_line", pos = "left", val = bks, frame = TRUE))
expect_silent(leg(type = "choro_line", pos = "bottomleft", val = bks, no_data = TRUE))
expect_silent(leg(type = "choro_line", pos = "top", val = bks, pal = hcl.colors(4, "Reds 2"), alpha = .5))
expect_silent(leg(type = "choro_line", val = c(10, 50), pos = c(.5,.5)))
expect_error(leg(type = "choro_line", val = 10, pos = "topright"), class = "error")
expect_error(leg(type = "choro_line", val = 10, pos = "topright", horiz = TRUE), class = "error")


## choro_symb
graphics.off()
plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
     type = "n", xlab = NA, ylab = NA, axes = FALSE)
bks <- c(10, 20, 30, 40, 50)
expect_silent(leg(type = "choro_symb", pos = "topleft", val = bks))
expect_silent(leg(type = "choro_symb", pos = "left", val = bks, frame = TRUE))
expect_silent(leg(type = "choro_symb", pos = "bottomleft", val = bks, no_data = TRUE))
expect_silent(leg(type = "choro_symb", pos = "top", val = bks, pal = hcl.colors(4, "Reds 2"), alpha = .5))
expect_silent(leg(type = "choro_symb", val = c(10, 50), pos = c(.5,.5)))
expect_error(leg(type = "choro_symb", val = 10, pos = "topright"), class = "error")
expect_error(leg(type = "choro_symb", val = 10, pos = "topright", horiz = TRUE), class = "error")


## typo_line
graphics.off()
plot(x = 0, y = 0, xlim = c(0, 1), ylim = c(0, 1),
     type = "n", xlab = NA, ylab = NA, axes = FALSE)
mod <- c("mod 1", "mod 2 ", "mod 3")
expect_silent(leg(type = "typo_line", pos = "topleft", val = mod))
expect_silent(leg(type = "typo_line", pos = "left", val = mod, frame = TRUE))
expect_silent(leg(type = "typo_line", pos = "bottomleft", val = mod, no_data = TRUE))
expect_silent(leg(type = "typo_line", pos = "top", val = mod, pal = hcl.colors(4, "Reds 2"), alpha = .5))
expect_silent(leg(type = "typo_line", val = mod, pos = c(.5,.5)))
expect_silent(leg(type = "typo_line", val = 10, pos = "topright"))

leg_histo <- function(pos = "left",
                      val,
                      pal = "Inferno",
                      alpha = NULL,
                      title = "Legend Title",
                      title_cex = .8 * size,
                      val_cex = .6 * size,
                      val_rnd = 0,
                      val_dec = ".",
                      val_big = "",
                      col_na = "white",
                      no_data = FALSE,
                      no_data_txt = "No Data",
                      frame = FALSE,
                      frame_border = fg,
                      box_border = "#333333",
                      bg = "#f7f7f7",
                      fg = "#333333",
                      size = 1,
                      box_cex = c(1, 1),
                      return_bbox = FALSE,
                      adj = c(0, 0)) {
  # spacings
  x_spacing <- xinch(par("csi")) / 4
  y_spacing <- yinch(par("csi")) / 4

  # n bars
  n_bar <- length(val$breaks) - 1

  # bar heights
  hh <- val$density

  # select values for x axis
  bks <- val$breaks
  vleg <- c(min(bks), max(bks))
  pleg <- pretty(vleg, min.n = 3)
  pe <- pleg[2] - pleg[1]
  if ((vleg[1] - pleg[1]) > (pe / 4)) {
    pleg <- pleg[-1]
  }
  if ((pleg[length(pleg)] - vleg[2]) > (pe / 4)) {
    pleg <- pleg[-length(pleg)]
  }
  vmin <- min(vleg, pleg)
  vmax <- max(vleg, pleg)
  vleg <- pleg
  valo <- get_val_rnd(val = bks, val_rnd = val_rnd, val_dec = val_dec, val_big = val_big)
  val <- get_val_rnd(val = vleg, val_rnd = val_rnd, val_dec = val_dec, val_big = val_big)

  # bar colors
  pal <- get_pal(pal, n_bar, alpha = alpha)

  # title dimensions
  title_dim <- get_title_dim(title, title_cex)

  # graph size
  hist_dim <- list(
    w = box_cex[1] * size * x_spacing * 5 * n_bar,
    h = box_cex[2] * size * y_spacing * 5 * 2
  )

  # label dimension
  r <- strwidth(valo[1], units = "user", cex = val_cex, font = 1) / 2
  s <- strwidth(valo[length(valo)], units = "user", cex = val_cex, font = 1) / 2
  labels_dim <- list(
    w = r + s + hist_dim$w,
    h = max(strheight(val, units = "user", cex = val_cex, font = 1))
  )

  # legend dimension
  legend_dim <- list(
    w = x_spacing +
      max(
        title_dim$w,
        labels_dim$w
      ) +
      x_spacing,
    h = y_spacing +
      ifelse(title_dim$h != 0, title_dim$h + 2 * y_spacing * size, 0) +
      hist_dim$h + y_spacing +
      labels_dim$h +
      y_spacing
  )

  # get legend coordinates
  legend_coords <- get_legend_coords(
    pos = pos, legend_dim = legend_dim,
    adj = adj, frame = frame,
    x_spacing = x_spacing,
    y_spacing = y_spacing
  )

  # return legend coordinates only
  if (return_bbox) {
    return(invisible(legend_coords))
  }

  # display frame
  plot_frame(
    frame = frame, legend_coords = legend_coords,
    bg = bg, frame_border = frame_border,
    x_spacing = x_spacing, y_spacing = y_spacing
  )

  # display title
  plot_title(
    title = title, title_cex = title_cex, title_dim = title_dim,
    fg = fg, legend_coords = legend_coords,
    x_spacing = x_spacing, y_spacing = y_spacing
  )

  # display bars
  left_init <- legend_coords$left + x_spacing + r
  bottom <- rep(legend_coords$bottom + y_spacing + labels_dim$h + y_spacing, n_bar)
  top <- bottom + hist_dim$h * hh / max(hh)
  w_bars <- hist_dim$w * ((bks - vmin) / (vmax - vmin))
  left <- w_bars[-length(w_bars)] + left_init
  right <- w_bars[-1] + left_init
  rect(
    xleft = left, ybottom = bottom, xright = right,
    ytop = top, col = pal, border = box_border, lwd = .5
  )

  # display labels
  x <- left_init + hist_dim$w * ((vleg - vmin) / (vmax - vmin))
  y <- rep(bottom[1] - y_spacing, length(vleg))
  text(x = x, y = y, labels = val, cex = val_cex, adj = c(0.5, 1), col = fg)
  segments(
    x0 = x, y0 = bottom, x1 = x, y1 = bottom - y_spacing / 2,
    col = box_border, lwd = .7
  )

  return(invisible(NULL))
}

leg_choro_line <- function(pos = "topleft",
                           val,
                           pal = "Inferno",
                           alpha = NULL,
                           lwd = 2,
                           title = "Legend Title",
                           title_cex = .8 * size,
                           val_cex = .6 * size,
                           val_rnd = 2,
                           val_dec = ".",
                           val_big = "",
                           frame = FALSE,
                           frame_border = fg,
                           bg = "#f7f7f7",
                           fg = "#333333",
                           col_na = "grey80",
                           no_data = FALSE,
                           no_data_txt = "No Data",
                           size = 1,
                           box_cex = c(1, 1),
                           return_bbox = FALSE,
                           adj = c(0, 0)) {
  # spacings
  x_spacing <- xinch(par("csi")) / 4
  y_spacing <- yinch(par("csi")) / 4

  # boxes sizes
  w_box <- box_cex[1] * size * x_spacing * 5
  h_box <- box_cex[2] * size * y_spacing * 5 * 3 / 5

  # Nb. boxes and values
  n_val <- length(val)
  n_box <- n_val - 1
  if (n_val < 2) {
    stop("You need to provide at least two values for 'val'", call. = FALSE)
  }

  # rounded and ordered values for the legend
  val <- get_val_rnd(val = val, val_rnd = val_rnd, val_dec = val_dec, val_big = val_big)

  # color mgmt
  pal <- rev(get_pal(pal, n_box, alpha = alpha))

  # title dimensions
  title_dim <- get_title_dim(title, title_cex)

  # boxes dimensions
  boxes_dim <- list(w = w_box, h = n_box * h_box)

  # label dimension
  labels_dim <- list(
    w = max(strwidth(val, units = "user", cex = val_cex, font = 1)),
    h = strheight(val[1], units = "user", cex = val_cex, font = 1) / 2 +
      strheight(val[n_val], units = "user", cex = val_cex, font = 1) / 2 +
      n_box * h_box
  )

  # NA box and label dimensions
  if (isTRUE(no_data)) {
    na_box_dim <- list(w = w_box, h = h_box)
    na_label_dim <- list(
      w = strwidth(no_data_txt, units = "user", cex = val_cex, font = 1),
      h = max(
        strheight(no_data_txt, units = "user", cex = val_cex, font = 1),
        h_box
      )
    )
  } else {
    na_box_dim <- list(w = 0, h = 0)
    na_label_dim <- list(w = 0, h = 0)
    no_data_txt <- ""
  }


  # legend dimension
  legend_dim <- list(
    w = x_spacing +
      max(
        title_dim$w,
        boxes_dim$w + labels_dim$w + x_spacing,
        na_box_dim$w + na_label_dim$w + x_spacing
      ) +
      x_spacing,
    h = y_spacing +
      ifelse(title_dim$h != 0, title_dim$h + 2 * y_spacing * size, 0) +
      labels_dim$h +
      ifelse(na_label_dim$h != 0, na_label_dim$h + y_spacing * size, 0) +
      y_spacing
  )

  # get legend coordinates
  legend_coords <- get_legend_coords(
    pos = pos, legend_dim = legend_dim,
    adj = adj, frame = frame,
    x_spacing = x_spacing,
    y_spacing = y_spacing
  )

  # return legend coordinates only
  if (return_bbox) {
    return(invisible(legend_coords))
  }

  # display frame
  plot_frame(
    frame = frame, legend_coords = legend_coords,
    bg = bg, frame_border = frame_border,
    x_spacing = x_spacing, y_spacing = y_spacing
  )

  # display title
  plot_title(
    title = title, title_cex = title_cex, title_dim = title_dim,
    fg = fg, legend_coords = legend_coords,
    x_spacing = x_spacing, y_spacing = y_spacing
  )

  # display boxes
  left <- rep(legend_coords$left + x_spacing, n_box)
  right <- left + w_box
  y <- legend_coords$top - y_spacing -
    ifelse(title_dim$h != 0, title_dim$h + 2 * y_spacing * size, 0) -
    strheight(val[1], units = "user", cex = val_cex, font = 1) / 2
  top <- rep(NA, n_box)
  for (i in 1:n_box) {
    top[i] <- y - (i - 1) * h_box
  }
  center <- top - h_box / 2
  segments(
    x0 = left, y0 = center, x1 = right, y1 = center, col = pal,
    lwd = lwd, lend = 1
  )

  # display labels
  x <- rep(legend_coords$left + x_spacing + w_box + x_spacing, n_val)
  y <- rep(NA, n_val)
  top <- top[1]
  for (i in 1:n_val) {
    y[i] <- top - (i - 1) * h_box
  }
  text(x = x, y = y, labels = rev(val), cex = val_cex, adj = c(0, 0.5), col = fg)

  if (isTRUE(no_data)) {
    # display na box
    left <- legend_coords$left + x_spacing
    right <- left + w_box
    bottom <- legend_coords$bottom + y_spacing +
      (na_label_dim$h - na_box_dim$h) / 2
    top <- bottom + h_box

    segments(
      x0 = left, y0 = bottom + h_box / 2, x1 = right, y1 = bottom + h_box / 2,
      col = col_na, lwd = lwd, lend = 1
    )

    # display na label
    x <- legend_coords$left + x_spacing + w_box + x_spacing
    y <- bottom + (top - bottom) / 2
    text(
      x = x, y = y, labels = no_data_txt, cex = val_cex, adj = c(0, 0.5),
      col = fg
    )
  }
  return(invisible(NULL))
}

leg_symb <- function(pos = "left",
                     val,
                     pal = "Inferno",
                     alpha = NULL,
                     pch = seq_along(val),
                     cex = rep(1, length(val)),
                     border = "#333333",
                     lwd = .7,
                     title = "Legend title",
                     title_cex = .8 * size,
                     val_cex = .6 * size,
                     cex_na = 1,
                     pch_na = 4,
                     col_na = "grey80",
                     no_data = FALSE,
                     no_data_txt = "No Data",
                     frame = FALSE,
                     frame_border = fg,
                     bg = "#f7f7f7",
                     fg = "#333333",
                     size = 1,
                     box_cex = c(1, 1),
                     return_bbox = FALSE,
                     adj = c(0, 0)) {
  # spacings
  x_spacing <- xinch(par("csi")) / 4
  y_spacing <- yinch(par("csi")) / 4

  # n. symbols
  n_val <- length(val)

  # symbol color
  col <- pbg <- get_pal(pal, n_val, alpha = alpha)
  if (any(pch %in% 21:25)) {
    col[pch %in% 21:25] <- border[pch %in% 21:25]
  }
  if (no_data) {
    col_na_bg <- col_na
    col_na[pch_na %in% 21:25] <- border[1]
  }

  # symbols attributes
  if (length(pch) == 1) {
    pch <- rep(pch, n_val)
  }
  if (length(cex) != n_val) {
    cex <- rep(cex[1], n_val)
  }
  if (length(lwd) != n_val) {
    lwd <- rep(lwd[1], n_val)
  }

  # symbol sizes
  symb_sizes <- list(w = rep(NA, n_val), h = rep(NA, n_val))
  for (i in seq_len(n_val)) {
    symb_sizes$w[i] <- strwidth("M", units = "user", cex = cex[i]) * .75 * box_cex[1]
    symb_sizes$h[i] <- strheight("M", units = "user", cex = cex[i]) * .75 * box_cex[2]
  }

  # title dimensions
  title_dim <- get_title_dim(title, title_cex)

  # label dimension
  labels_dim <- list(
    w = max(strwidth(val, units = "user", cex = val_cex, font = 1))
  )

  # label (+) box dim
  max_sizes <- pmax(
    strheight(val, units = "user", cex = val_cex, font = 1),
    symb_sizes$h
  )

  # NA box and label dimensions
  if (isTRUE(no_data)) {
    na_box_dim <- list(
      w = strwidth("M", units = "user", cex = cex_na) * .75 * box_cex[1],
      h = strheight("M", units = "user", cex = cex_na) * .75 * box_cex[2]
    )
    na_label_dim <- list(
      w = strwidth(no_data_txt, units = "user", cex = val_cex, font = 1),
      h = max(strheight(no_data_txt, units = "user", cex = val_cex, font = 1), na_box_dim$h)
    )
  } else {
    na_box_dim <- list(w = 0, h = 0)
    na_label_dim <- list(w = 0, h = 0)
    no_data_txt <- ""
  }

  # legend dimension
  legend_dim <- list(
    w = x_spacing +
      max(
        title_dim$w,
        max(symb_sizes$w) + labels_dim$w + x_spacing,
        max(na_box_dim$w) + na_label_dim$w + x_spacing
      ) +
      x_spacing,
    h = y_spacing +
      ifelse(title_dim$h != 0, title_dim$h + 2 * y_spacing * size, 0) +
      sum(max_sizes) + (n_val - 1) * y_spacing +
      ifelse(na_label_dim$h != 0, na_label_dim$h + y_spacing * size, 0) +
      y_spacing
  )

  # get legend coordinates
  legend_coords <- get_legend_coords(
    pos = pos, legend_dim = legend_dim,
    adj = adj, frame = frame,
    x_spacing = x_spacing,
    y_spacing = y_spacing
  )

  # return legend coordinates only
  if (return_bbox) {
    return(invisible(legend_coords))
  }

  # display frame
  plot_frame(
    frame = frame, legend_coords = legend_coords,
    bg = bg, frame_border = frame_border,
    x_spacing = x_spacing, y_spacing = y_spacing
  )

  # display title
  plot_title(
    title = title, title_cex = title_cex, title_dim = title_dim,
    fg = fg, legend_coords = legend_coords,
    x_spacing = x_spacing, y_spacing = y_spacing
  )


  center_h <- rep(NA, n_val)
  center_h[1] <- legend_coords$top - y_spacing -
    ifelse(title_dim$h != 0, title_dim$h + 2 * y_spacing * size, 0) -
    max_sizes[1] / 2
  if (n_val > 1) {
    for (i in 2:n_val) {
      center_h[i] <- center_h[i - 1] - max_sizes[i - 1] / 2 - y_spacing - max_sizes[i] / 2
    }
  }
  center_w <- rep(legend_coords$left + x_spacing + max(symb_sizes$w, na_box_dim$w) / 2, n_val)
  for (i in seq_len(n_val)) {
    points(
      x = center_w[i],
      y = center_h[i],
      col = col[i],
      pch = pch[[i]],
      cex = cex[i],
      bg = pbg[i],
      lwd = lwd[i]
    )
  }
  text(
    x = center_w + x_spacing + max(symb_sizes$w, na_box_dim$w) / 2,
    y = center_h,
    labels = val,
    cex = val_cex,
    adj = c(0, 0.5),
    col = fg
  )

  if (isTRUE(no_data)) {
    # display na box
    bottom <- legend_coords$bottom + y_spacing + na_label_dim$h / 2
    points(
      x = center_w[i],
      y = bottom,
      col = col_na,
      pch = pch_na,
      cex = cex_na,
      bg = col_na_bg,
      lwd = lwd
    )

    # display na label
    text(
      x = center_w[1] + x_spacing + max(symb_sizes$w, na_box_dim$w) / 2,
      y = bottom,
      labels = no_data_txt,
      cex = val_cex,
      adj = c(0, 0.5),
      col = fg
    )
  }


  return(invisible(NULL))
}

leg_prop_h <- function(pos = "left",
                       val,
                       col = "tomato4",
                       alpha = NULL,
                       inches = .3,
                       val_max = NULL,
                       symbol = "circle",
                       border = "#333333",
                       lwd = .7,
                       title = "Legend Title",
                       title_cex = .8 * size,
                       val_cex = .6 * size,
                       val_rnd = 0,
                       val_dec = ".",
                       val_big = "",
                       frame = FALSE,
                       frame_border = fg,
                       bg = "#f7f7f7",
                       fg = "#333333",
                       size = 1,
                       box_cex = 1,
                       self_adjust = FALSE,
                       return_bbox = FALSE,
                       adj = c(0, 0)) {
  # spacings
  x_spacing <- xinch(par("csi")) / 4
  y_spacing <- yinch(par("csi")) / 4

  # color mgmt
  col <- ifelse(!is.null(alpha), get_hex_pal(col, alpha), col)
  border <- border[[1]]
  lwd <- lwd[[1]]

  # values & values labels
  val <- unique(val)
  if (self_adjust == TRUE) {
    val <- self_adjust_v(val, inches, val_cex)
  }
  val <- sort(val, decreasing = TRUE)
  n_val <- length(val)
  valleg <- get_val_rnd(val = val, val_rnd = val_rnd, val_dec = val_dec, val_big = val_big)

  # title dimensions
  title_dim <- get_title_dim(title, title_cex)

  # adjust max_val
  if (is.null(val_max)) {
    val_max <- max(val)
  }

  # largest symbol size
  symb_sizes <- list(inches = sqrt(val * inches * inches / val_max))
  symb_sizes$x <- xinch(symb_sizes$inches)
  symb_sizes$y <- yinch(symb_sizes$inches)
  inches <- max(symb_sizes$inches)
  symb_dim <- list(
    w = sum(symb_sizes$x) + (n_val - 1) * x_spacing,
    h = yinch(inches * 2)
  )

  # label dimension
  labels_dim <- list(
    h = strheight(valleg[1], units = "user", cex = val_cex, font = 1)
  )

  # label (+) symb dim
  max_sizes <- pmax(
    strwidth(valleg, units = "user", cex = val_cex, font = 1),
    symb_sizes$x * 2
  )

  # legend dimension
  legend_dim <- list(
    w = x_spacing +
      max(
        title_dim$w,
        sum(max_sizes) + x_spacing * (n_val - 1)
      ) +
      x_spacing,
    h = y_spacing +
      ifelse(title_dim$h != 0, title_dim$h + 2 * y_spacing * size, 0) +
      symb_dim$h + y_spacing + labels_dim$h +
      y_spacing
  )

  # get legend coordinates
  legend_coords <- get_legend_coords(
    pos = pos, legend_dim = legend_dim,
    adj = adj, frame = frame,
    x_spacing = x_spacing,
    y_spacing = y_spacing
  )


  # return legend coordinates only
  if (return_bbox) {
    return(invisible(legend_coords))
  }

  # display frame
  plot_frame(
    frame = frame, legend_coords = legend_coords,
    bg = bg, frame_border = frame_border,
    x_spacing = x_spacing, y_spacing = y_spacing
  )

  # display title
  plot_title(
    title = title, title_cex = title_cex, title_dim = title_dim,
    fg = fg, legend_coords = legend_coords,
    x_spacing = x_spacing, y_spacing = y_spacing
  )

  # display symbols & lines
  pal <- rep(col, n_val)

  x <- rep(NA, n_val)
  x[1] <- legend_coords$left + x_spacing + max_sizes[1] / 2
  if (n_val > 1) {
    for (i in 2:n_val) {
      x[i] <- x[i - 1] + max_sizes[i - 1] / 2 + x_spacing + max_sizes[i] / 2
    }
  }
  y <- legend_coords$top - y_spacing -
    ifelse(title_dim$h != 0, title_dim$h + 2 * y_spacing * size, 0) -
    symb_sizes$y[1] * 2 + symb_sizes$y
  if (symbol == "circle") {
    symbols(
      x = x,
      y = y,
      circles = symb_sizes$inches,
      bg = pal,
      fg = border,
      lwd = lwd,
      add = TRUE,
      inches = inches,
    )
    # display labels
    text(
      x = x,
      y = legend_coords$bottom + y_spacing,
      labels = valleg, cex = val_cex, adj = c(0.5, 0), col = fg
    )
  }
  if (symbol == "square") {
    symbols(
      x = x,
      y = y,
      squares = symb_sizes$inches,
      bg = pal,
      fg = border,
      lwd = lwd,
      add = TRUE,
      inches = inches * 2,
    )
    # display labels
    text(
      x = x,
      y = legend_coords$bottom + y_spacing,
      labels = valleg, cex = val_cex, adj = c(0.5, 0), col = fg
    )
  }

  return(invisible(NULL))
}

leg_prop_line <- function(pos = "left",
                          val,
                          lwd = .7,
                          col = "tomato4",
                          alpha = NULL,
                          title = "Legend Title",
                          title_cex = .8 * size,
                          val_cex = .6 * size,
                          val_rnd = 0,
                          val_dec = ".",
                          val_big = "",
                          frame = FALSE,
                          frame_border = fg,
                          bg = "#f7f7f7",
                          fg = "#333333",
                          size = 1,
                          box_cex = c(1, 1),
                          return_bbox = FALSE,
                          adj = c(0, 0)) {
  # spacings
  x_spacing <- xinch(par("csi")) / 4
  y_spacing <- yinch(par("csi")) / 4

  # color mgmt
  col <- ifelse(!is.null(alpha), get_hex_pal(col, alpha), col)

  # boxes sizes
  w_box <- box_cex[1] * size * x_spacing * 5

  # values & values labels
  val <- unique(sort(val, decreasing = TRUE))
  valleg <- get_val_rnd(val = val, val_rnd = val_rnd, val_dec = val_dec, val_big = val_big)

  # Nb. boxes and values
  n_val <- n_box <- length(val)

  # symbol sizes
  lwds <- lwd * val / max(val)

  # title dimensions
  title_dim <- get_title_dim(title, title_cex)

  # boxes dimensions
  boxes_dim <- list(w = w_box)

  # label dimension
  labels_dim <- list(
    w = max(strwidth(valleg, units = "user", cex = val_cex, font = 1))
  )

  # label (+) box dim
  max_sizes <- pmax(
    strheight(valleg, units = "user", cex = val_cex, font = 1),
    yinch(lwds / 96)
  )

  # legend dimension
  legend_dim <- list(
    w = x_spacing +
      max(
        title_dim$w,
        boxes_dim$w + labels_dim$w + x_spacing
      ) +
      x_spacing,
    h = y_spacing +
      ifelse(title_dim$h != 0, title_dim$h + 2 * y_spacing * size, 0) +
      sum(max_sizes) + (n_box - 1) * y_spacing +
      y_spacing
  )

  # get legend coordinates
  legend_coords <- get_legend_coords(
    pos = pos, legend_dim = legend_dim,
    adj = adj, frame = frame,
    x_spacing = x_spacing,
    y_spacing = y_spacing
  )

  # return legend coordinates only
  if (return_bbox) {
    return(invisible(legend_coords))
  }

  # display frame
  plot_frame(
    frame = frame, legend_coords = legend_coords,
    bg = bg, frame_border = frame_border,
    x_spacing = x_spacing, y_spacing = y_spacing
  )

  # display title
  plot_title(
    title = title, title_cex = title_cex, title_dim = title_dim,
    fg = fg, legend_coords = legend_coords,
    x_spacing = x_spacing, y_spacing = y_spacing
  )

  # display lines
  center <- rep(NA, n_val)
  center[1] <- legend_coords$top - y_spacing -
    ifelse(title_dim$h != 0, title_dim$h + 2 * y_spacing * size, 0) -
    max_sizes[1] / 2
  if (n_val > 1) {
    for (i in 2:n_val) {
      center[i] <- center[i - 1] - max_sizes[i - 1] / 2 - y_spacing - max_sizes[i] / 2
    }
  }
  left <- rep(legend_coords$left + x_spacing, n_box)
  right <- left + w_box
  segments(
    x0 = left,
    y0 = center,
    x1 = right,
    y1 = center,
    col = col,
    lwd = lwds,
    lend = 1
  )

  # display labels
  x <- rep(legend_coords$left + x_spacing + w_box + x_spacing, n_val)
  y <- center
  text(x = x, y = y, labels = valleg, cex = val_cex, adj = c(0, 0.5), col = fg)

  return(invisible(NULL))
}

leg_choro <- function(pos = "left",
                      val,
                      pal = "Inferno",
                      alpha = NULL,
                      title = "Legend Title",
                      title_cex = .8 * size,
                      val_cex = .6 * size,
                      val_rnd = 0,
                      val_dec = ".",
                      val_big = "",
                      col_na = "white",
                      no_data = FALSE,
                      no_data_txt = "No Data",
                      frame = FALSE,
                      frame_border = fg,
                      box_border = "#333333",
                      bg = "#f7f7f7",
                      fg = "#333333",
                      size = 1,
                      box_cex = c(1, 1),
                      return_bbox = FALSE,
                      adj = c(0, 0)) {
  # spacings
  x_spacing <- xinch(par("csi")) / 4
  y_spacing <- yinch(par("csi")) / 4

  # boxes sizes
  w_box <- box_cex[1] * size * x_spacing * 5
  h_box <- box_cex[2] * size * y_spacing * 5 * 2 / 3

  # Nb. boxes and values
  n_val <- length(val)
  n_box <- n_val - 1

  # rounded and ordered values for the legend
  val <- rev(get_val_rnd(val = val, val_rnd = val_rnd, val_dec = val_dec, val_big = val_big))

  # box colors
  pal <- rev(get_pal(pal, n_box, alpha = alpha))

  # title dimensions
  title_dim <- get_title_dim(title, title_cex)

  # boxes dimensions
  boxes_dim <- list(w = w_box, h = n_box * h_box)

  # label dimension
  labels_dim <- list(
    w = max(strwidth(val, units = "user", cex = val_cex, font = 1)),
    h = strheight(val[1], units = "user", cex = val_cex, font = 1) / 2 +
      strheight(val[n_val], units = "user", cex = val_cex, font = 1) / 2 +
      n_box * h_box
  )

  # NA box and label dimensions
  if (isTRUE(no_data)) {
    na_box_dim <- list(w = w_box, h = h_box)
    na_label_dim <- list(
      w = strwidth(no_data_txt, units = "user", cex = val_cex, font = 1),
      h = max(strheight(no_data_txt, units = "user", cex = val_cex, font = 1), h_box)
    )
  } else {
    na_box_dim <- list(w = 0, h = 0)
    na_label_dim <- list(w = 0, h = 0)
    no_data_txt <- ""
  }

  # legend dimension
  legend_dim <- list(
    w = x_spacing +
      max(
        title_dim$w,
        boxes_dim$w + labels_dim$w + x_spacing,
        na_box_dim$w + na_label_dim$w + x_spacing
      ) +
      x_spacing,
    h = y_spacing +
      ifelse(title_dim$h != 0, title_dim$h + 2 * y_spacing * size, 0) +
      labels_dim$h +
      ifelse(na_label_dim$h != 0, na_label_dim$h + y_spacing * size, 0) +
      y_spacing
  )

  # get legend coordinates
  legend_coords <- get_legend_coords(
    pos = pos, legend_dim = legend_dim,
    adj = adj, frame = frame,
    x_spacing = x_spacing,
    y_spacing = y_spacing
  )

  # return legend coordinates only
  if (return_bbox) {
    return(invisible(legend_coords))
  }


  # display frame
  plot_frame(
    frame = frame, legend_coords = legend_coords,
    bg = bg, frame_border = frame_border,
    x_spacing = x_spacing, y_spacing = y_spacing
  )

  # display title
  plot_title(
    title = title, title_cex = title_cex, title_dim = title_dim,
    fg = fg, legend_coords = legend_coords,
    x_spacing = x_spacing, y_spacing = y_spacing
  )

  # display boxes
  left <- rep(legend_coords$left + x_spacing, n_box)
  right <- left + w_box
  y <- legend_coords$top - y_spacing -
    ifelse(title_dim$h != 0, title_dim$h + 2 * y_spacing * size, 0) -
    strheight(val[1], units = "user", cex = val_cex, font = 1) / 2
  top <- rep(NA, n_box)
  for (i in 1:n_box) {
    top[i] <- y - (i - 1) * h_box
  }
  bottom <- top - h_box
  rect(
    xleft = left, ybottom = bottom, xright = right, ytop = top,
    col = pal, border = box_border, lwd = .7
  )

  # display labels
  x <- rep(legend_coords$left + x_spacing + w_box + x_spacing, n_val)
  y <- rep(NA, n_val)
  top <- top[1]
  for (i in 1:n_val) {
    y[i] <- top - (i - 1) * h_box
  }
  text(x = x, y = y, labels = val, cex = val_cex, adj = c(0, 0.5), col = fg)

  if (isTRUE(no_data)) {
    # display na box
    left <- legend_coords$left + x_spacing
    right <- left + w_box
    bottom <- legend_coords$bottom + y_spacing + (na_label_dim$h - na_box_dim$h) / 2
    top <- bottom + h_box
    rect(
      xleft = left, ybottom = bottom, xright = right, ytop = top,
      col = col_na, border = box_border, lwd = .7
    )

    # display na label
    x <- legend_coords$left + x_spacing + w_box + x_spacing
    y <- bottom + (top - bottom) / 2
    text(x = x, y = y, labels = no_data_txt, cex = val_cex, adj = c(0, 0.5), col = fg)
  }
  return(invisible(NULL))
}

leg_cont <- function(pos = "left",
                     val,
                     pal = "Inferno",
                     alpha = NULL,
                     title = "Legend Title",
                     title_cex = .8 * size,
                     val_cex = .6 * size,
                     val_rnd = 0,
                     val_dec = ".",
                     val_big = "",
                     col_na = "white",
                     no_data = FALSE,
                     no_data_txt = "No Data",
                     frame = FALSE,
                     frame_border = fg,
                     box_border = "#333333",
                     bg = "#f7f7f7",
                     fg = "#333333",
                     size = 1,
                     box_cex = c(1, 1),
                     horiz = FALSE,
                     return_bbox = FALSE,
                     adj = c(0, 0)) {
  box_cex <- eval(box_cex)
  pal <- eval(pal)
  if (length(pal) != 1) {
    pal <- grDevices::colorRampPalette(colors = pal, alpha = TRUE)(100)
  } else {
    pal <- grDevices::hcl.colors(n = 100, palette = pal, rev = TRUE, alpha = alpha)
  }
  val <- val_cont(val, val_rnd, val_dec, val_big)
  box_cex[1] <- box_cex[1] * .4
  box_cex[2] <- box_cex[2] * .05

  leg_choro(
    val = val, pos = pos, pal = pal, title = title,
    title_cex = title_cex, alpha = alpha,
    val_cex = val_cex, val_rnd = val_rnd, col_na = col_na, no_data = no_data,
    val_dec = val_dec, val_big = val_big,
    no_data_txt = no_data_txt, frame = frame, box_border = NA, bg = bg,
    fg = fg, frame_border = frame_border,
    size = size, box_cex = box_cex,
    return_bbox = return_bbox, adj = adj
  )
}

#' @title Plot a composed map legend
#' @description Draw a map legend with several elements.
#' @param x list of legend parameters
#' @param pos position of the legend. . It can be one of 'topleft',
#' 'topright', 'right', 'bottomright', 'bottomleft' or 'left',
#' @param size size of the legend; 2 means two times bigger
#' @param bg background color of the legend
#' @param fg foreground color of the legend
#' @param frame if TRUE the legend is plotted within a frame
#' @param adj adjust the postion of the legend in x and y directions.
#' @param mar plot margins
#' @param title_cex size of the legend title
#' @param val_cex size of the values in the legend
#' @param frame_border border color of the frame
#' @return A composed legend is plotted. Nothing is returned.
#' @export
#'
#' @examples
#' # minimal example
#' plot.new()
#' plot.window(xlim = c(0, 1), ylim = c(0, 1), asp = 1)
#' box()
#' leg_comp(type = "prop", val = c(10, 50, 100)) |>
#'   leg_comp(type = "typo", val = c("A", "B", "C")) |>
#'   leg_draw(pos = "topright", bg = "lightblue")
leg_draw <- function(x,
                     pos = "bottomright",
                     size = 1,
                     bg = "#f7f7f7",
                     fg = "#333333",
                     frame = TRUE,
                     frame_border = fg,
                     title_cex = 0.8 * size,
                     val_cex = 0.6 * size,
                     adj = c(0, 0),
                     mar = par("mar")) {
  if (any(is.na(pos))) {
    return(invisible(NULL))
  }

  if (length(pos) == 1 && pos == "interactive") {
    pos <- interleg()
  }

  grDevices::recordGraphics(
    expr = {
      dimleg <- list()
      for (i in seq_along(x$layers)) {
        x$layers[[i]]$pos <- pos
        x$layers[[i]]$return_bbox <- TRUE
        x$layers[[i]]$mar <- mar
        x$layers[[i]]$size <- size
        x$layers[[i]]$frame <- frame
        x$layers[[i]]$adj <- adj
        x$layers[[i]]$title_cex <- title_cex
        x$layers[[i]]$val_cex <- val_cex

        dimleg[[i]] <- do.call(leg, x$layers[[i]])
      }

      res <- get_pos_and_frame(pos = pos, dimleg = dimleg, adj = adj)
      xleg <- res$xleg
      yleg <- res$yleg

      if (frame) {
        frame_c <- res$frame_c
        rect(
          xleft = frame_c[1],
          ybottom = frame_c[3],
          xright = frame_c[2],
          ytop = frame_c[4],
          col = bg,
          border = frame_border,
          xpd = TRUE
        )
      }


      for (i in seq_along(x$layers)) {
        x$layers[[i]]$mar <- mar
        x$layers[[i]]$pos <- c(xleg[i], yleg[i])
        x$layers[[i]]$return_bbox <- FALSE
        x$layers[[i]]$frame <- FALSE
        x$layers[[i]]$bg <- bg
        x$layers[[i]]$fg <- fg
        x$layers[[i]]$adj <- c(0, 0)
        do.call(leg, x$layers[[i]])
      }
    },
    list = list(
      x = x, pos = pos, adj = adj, frame = frame, mar = mar, bg = bg,
      fg = fg, size = size, title_cex = title_cex, val_cex = val_cex,
      frame_border = frame_border
    ),
    env = getNamespace("maplegend")
  )
  return(invisible(NULL))
}


get_pos_and_frame <- function(pos, dimleg, adj) {
  xleft <- min(unlist(lapply(dimleg, function(x) {
    x$left
  })))
  xright <- max(unlist(lapply(dimleg, function(x) {
    x$right
  })))
  heights <- unlist(lapply(dimleg, function(x) {
    x$top - x$bottom
  }))
  height <- sum(heights)
  xleg <- rep(xleft, length(dimleg))

  if (is.numeric(pos)) {
    ytop <- max(unlist(lapply(dimleg, function(x) {
      x$top
    })))
    ybottom <- ytop - height
    yleg <- ybottom + rev(cumsum(rev(heights)))
  } else {
    if (startsWith(pos, "top")) {
      ytop <- max(unlist(lapply(dimleg, function(x) {
        x$top
      })))
      ybottom <- ytop - height
      yleg <- ybottom + rev(cumsum(rev(heights)))
    }
    if (startsWith(pos, "bottom")) {
      ybottom <- min(unlist(lapply(dimleg, function(x) {
        x$bottom
      })))
      ytop <- ybottom + height
      yleg <- ybottom + rev(cumsum(rev(heights)))
    }
    if (pos %in% c("left", "right")) {
      ymid <- dimleg[[1]][[3]] - (dimleg[[1]][[3]] - dimleg[[1]][[4]]) / 2
      ytop <- ymid + height / 2
      ybottom <- ytop - height
      yleg <- ybottom + rev(cumsum(rev(heights)))
    }
  }

  return(list(
    xleg = xleg,
    yleg = yleg,
    frame_c = c(
      xmin = xleft,
      xmax = xright,
      ymin = ybottom,
      ymax = ytop
    )
  ))
}

leg_cont_h <- function(pos = "left",
                       val,
                       pal = "Inferno",
                       alpha = NULL,
                       title = "Legend Title",
                       title_cex = .8 * size,
                       val_cex = .6 * size,
                       val_rnd = 0,
                       val_dec = ".",
                       val_big = "",
                       col_na = "white",
                       no_data = FALSE,
                       no_data_txt = "No Data",
                       frame = FALSE,
                       frame_border = fg,
                       box_border = "#333333",
                       bg = "#f7f7f7",
                       fg = "#333333",
                       size = 1,
                       box_cex = c(1, 1),
                       horiz = FALSE,
                       return_bbox = FALSE,
                       adj = c(0, 0)) {
  box_cex <- eval(box_cex)
  pal <- eval(pal)

  if (length(pal) != 1) {
    pal <- grDevices::colorRampPalette(colors = pal, alpha = TRUE)(100)
  } else {
    pal <- grDevices::hcl.colors(n = 100, palette = pal, rev = TRUE, alpha = alpha)
  }
  val <- val_cont(val, val_rnd, val_dec, val_big)

  box_cex[1] <- box_cex[1] * .05

  leg_choro_h(
    val = val, pos = pos, pal = pal,
    title = title, title_cex = title_cex, alpha = alpha,
    val_cex = val_cex, val_rnd = val_rnd, col_na = col_na,
    no_data = no_data,
    no_data_txt = no_data_txt, frame = frame, box_border = NA,
    bg = bg, fg = fg, val_dec = val_dec, val_big = val_big,
    size = size, box_cex = box_cex,
    frame_border = frame_border,
    return_bbox = return_bbox, adj = adj
  )
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/leg.R
\name{leg}
\alias{leg}
\title{Plot a single map legend}
\usage{
leg(
  type,
  val,
  pos = "left",
  pal = "Inferno",
  alpha = NULL,
  col = "tomato4",
  inches = 0.3,
  val_max = NULL,
  symbol = "circle",
  self_adjust = FALSE,
  lwd = 0.7,
  border = "#333333",
  pch = seq_along(val),
  cex = rep(1, length(val)),
  title = "Legend Title",
  title_cex = 0.8 * size,
  val_cex = 0.6 * size,
  val_rnd = 0,
  val_dec = ".",
  val_big = "",
  col_na = "white",
  cex_na = 1,
  pch_na = 4,
  no_data = FALSE,
  no_data_txt = "No Data",
  box_border = "#333333",
  box_cex = c(1, 1),
  horiz = FALSE,
  frame_border = fg,
  frame = FALSE,
  bg = "#f7f7f7",
  fg = "#333333",
  size = 1,
  return_bbox = FALSE,
  mar = par("mar"),
  adj = c(0, 0)
)
}
\arguments{
\item{type}{type of legend:
\itemize{
\item \strong{prop} for proportional symbols,
\item \strong{choro} for choropleth maps,
\item \strong{cont} for continuous maps (e.g. raster),
\item \strong{typo} for typology maps,
\item \strong{symb} for symbols maps,
\item \strong{prop_line} for proportional lines maps,
\item \strong{grad_line} for graduated lines maps,
\item \strong{histo} for histograms,
\item \strong{choro_point} for choropleth points maps,
\item \strong{choro_line} for choropleth lines maps,
\item \strong{choro_symb} for choropleth on symbols maps
\item \strong{typo_line} for typology lines maps.
}}

\item{val}{vector of value(s) (for "prop" and "prop_line", at least c(min, max)
for "cont"),
vector of categories (for "symb", "typo", "typo_line"),
break labels (for "choro", "choro_point", "choro_line", "choro_symb",
and "grad_line"),
histogram parameters (for "histo").}

\item{pos}{position of the legend. It can be one of 'topleft', 'top',
'topright', 'right', 'bottomright', 'bottom','bottomleft',
'left', 'interactive' or a vector of two coordinates
in map units (c(x, y)).}

\item{pal}{a color palette name or a vector of colors}

\item{alpha}{opacity, in the range [0,1]}

\item{col}{color of the symbols (for "prop") or color of the lines (for
"prop_line" and "grad_line")}

\item{inches}{size of the largest symbol (radius for circles, half width
for squares) in inches}

\item{val_max}{maximum value corresponding to the largest symbol}

\item{symbol}{type of symbols, 'circle' or 'square'}

\item{self_adjust}{if TRUE values are self-adjusted to keep min, max and
intermediate rounded values}

\item{lwd}{width(s) of the symbols borders (for "prop", "symb",
"choro_point", "choro_symb"),
width of the largest line (for "prop_line"), line width (for "choro_line"
and "typo_line"), vector of line widths (for "grad_line")}

\item{border}{symbol border color(s)}

\item{pch}{type(s) of the symbols (0:25)}

\item{cex}{size(s) of the symbols}

\item{title}{title of the legend}

\item{title_cex}{size of the legend title}

\item{val_cex}{size of the values in the legend}

\item{val_rnd}{number of decimal places of the values in
the legend}

\item{val_dec}{decimal separator}

\item{val_big}{thousands separator}

\item{col_na}{color for missing values}

\item{cex_na}{size of the symbols for missing values}

\item{pch_na}{type of the symbols for missing values}

\item{no_data}{if TRUE a "missing value" box is plotted}

\item{no_data_txt}{label for missing values}

\item{box_border}{border color of legend boxes}

\item{box_cex}{width and height size expansion for boxes, histogram
circles, squares or lines}

\item{horiz}{if TRUE plot an horizontal legend}

\item{frame_border}{border color of the frame}

\item{frame}{if TRUE the legend is plotted within a frame}

\item{bg}{background color of the legend}

\item{fg}{foreground color of the legend}

\item{size}{size of the legend; 2 means two times bigger}

\item{return_bbox}{return only bounding box of the legend.
No legend is plotted.}

\item{mar}{plot margins}

\item{adj}{adjust the postion of the legend in x and y directions.}
}
\value{
No value is returned, a legend is displayed.
}
\description{
Plot different types of legend. The "type" argument defines the
legend type.
Please note that some arguments are available for all types of legend and
some others are only relevant for specific legend types (see Details).
}
\details{
Some arguments are available for all types of legend: \code{val}, \code{pos}, \code{title},
\code{title_cex}, \code{val_cex}, \code{frame}, \code{bg}, \code{fg}, \code{size}, \code{adj}, \code{alpha},
\code{return_bbox} and \code{mar}).

Relevant arguments for each specific legend types:
\itemize{
\item \code{leg(type = "prop", val, inches, val_max, symbol, col, lwd, border, val_rnd, val_big, val_dec, self_adjust, horiz)}
\item \code{leg(type = "choro", val, pal, val_rnd, val_big, val_dec, col_na, no_data, no_data_txt, box_border, box_cex, horiz)}
\item \code{leg(type = "cont", val, pal, val_rnd, val_big, val_dec, col_na, no_data, no_data_txt, box_border, box_cex, horiz)}
\item \code{leg(type = "typo", val, pal, col_na, no_data, no_data_txt, box_border, box_cex)}
\item \code{leg(type = "symb", val, pal, pch, cex, lwd, pch_na, cex_na, col_na, no_data, no_data_txt)}
\item \code{leg(type = "prop_line", val, col, lwd, val_rnd, val_big, val_dec)}
\item \code{leg(type = "grad_line", val, col, lwd, val_rnd, val_big, val_dec)}
\item \code{leg(type = "histo", val, pal, box_border, val_rnd, val_big, val_dec)}
\item \code{leg(type = "choro_point", val, pal, symbol, border, cex, val_rnd, val_big, val_dec, col_na, no_data, no_data_txt, horiz)}
\item \code{leg(type = "choro_line", val, pal, lwd, val_rnd, val_big, val_dec, col_na, no_data, no_data_txt)}
\item \code{leg(type = "choro_symb", val, pal, pch, lwd, val_rnd, val_big, val_dec, col_na, no_data, no_data_txt)}
\item \code{leg(type = "typo_line", val, pal, lwd, col_na, no_data, no_data_txt, box_cex)}
}
}
\examples{
# minimal example
plot.new()
plot.window(xlim = c(0, 1), ylim = c(0, 1), asp = 1)
box()
leg(type = "prop", val = c(10, 50, 100), pos = "topleft")
leg(type = "choro", val = c(10, 20, 30, 40, 50), pos = "bottomleft")
leg(type = "typo", val = c("A", "B", "C"), pos = "top")
leg(type = "symb", val = c("A", "B", "C"), pos = "topright")
leg(type = "prop_line", val = c(5, 50, 100), pos = "bottom", lwd = 20)
leg(
  type = "grad_line", val = c(1, 4, 10, 15), pos = "bottomright",
  lwd = c(1, 5, 10)
)
plot.new()
plot.window(xlim = c(0, 1), ylim = c(0, 1), asp = 1)
leg(type = "prop", val = c(10, 50, 100), pos = "topleft", horiz = TRUE)
leg(type = "choro", val = c(10, 20, 30, 40, 50), pos = "left", horiz = TRUE)
leg(
  type = "cont", val = c(10, 20, 30, 40, 50), pos = "bottomleft",
  horiz = TRUE
)
leg(type = "choro_point", val = c(10, 20, 30, 40, 50), pos = "top")
leg(
  type = "choro_point", val = c(10, 20, 30, 40, 50), pos = "right",
  horiz = TRUE
)
leg(
  type = "cont", val = c(10, 20, 30, 40, 50), pos = "topright",
  horiz = FALSE
)
set.seed(46)
leg(
  type = "histo", val = hist(rnorm(1000), breaks = 5, plot = FALSE),
  pos = "bottomright"
)
box()

plot.new()
plot.window(xlim = c(0, 1), ylim = c(0, 1), asp = 1)
leg(type = "choro_line", val = c(10, 20, 30, 40, 50), pos = "topleft")
leg(type = "typo_line", val = c("A", "B", "C"), pal = "Set 2", pos = "top")
leg(type = "choro_symb", val = c(10, 20, 30, 40, 50), pos = "topright")


# full example
plot.new()
plot.window(xlim = c(0, 1), ylim = c(0, 1))
leg(
  type = "prop",
  val = c(5, 100),
  pos = "top",
  inches = .4,
  symbol = "circle",
  col = "#940000",
  lwd = 1,
  border = "#9494ff",
  val_rnd = 1,
  self_adjust = TRUE,
  title = "Proportional Symbols",
  title_cex = 1,
  val_cex = .8,
  bg = "grey10",
  fg = "yellow",
  frame = TRUE
)

plot.new()
plot.window(xlim = c(0, 1), ylim = c(0, 1))
leg(
  type = "choro",
  alpha = 1,
  val = c(10, 20, 30, 40, 50),
  pos = "top",
  pal = c("#7F000D", "#B56C6F", "#DBBABB", "#F1F1F1"),
  val_rnd = 2,
  col_na = "grey",
  no_data = TRUE,
  no_data_txt = "No data",
  box_border = "cornsilk",
  box_cex = c(2, 1),
  title = "Choropleth (sequential)"
)

plot.new()
plot.window(xlim = c(0, 1), ylim = c(0, 1))
leg(
  type = "typo",
  val = c("A", "B", "C"),
  pos = "top",
  pal = "Dynamic",
  col_na = "grey",
  no_data = TRUE,
  no_data_txt = "No data",
  box_cex = c(1.2, 1),
  title = "Typology (categories)"
)

plot.new()
plot.window(xlim = c(0, 1), ylim = c(0, 1))
leg(
  type = "symb",
  val = c("A", "B", "C"),
  pos = "top",
  pch = 21:23,
  cex = c(4, 4, 2),
  pal = "Inferno",
  lwd = 2,
  border = "red",
  col_na = "grey",
  pch_na = 3,
  cex_na = 1,
  no_data = TRUE,
  no_data_txt = "No data",
  title = "Symbols"
)

plot.new()
plot.window(xlim = c(0, 1), ylim = c(0, 1))
leg(
  type = "cont",
  val = c(1, 2, 3, 4, 5),
  pos = "top",
  pal = "Inferno",
  alpha = .7,
  val_rnd = 2,
  horiz = TRUE,
  box_cex = c(2, 1),
  title = "Continuous"
)

plot.new()
plot.window(xlim = c(0, 1), ylim = c(0, 1))
leg(
  type = "prop_line",
  val = c(54, 505, 1025),
  pos = "top",
  lwd = 15,
  col = "green",
  val_rnd = -1,
  box_cex = c(2, .5),
  title = "Proportional Lines",
  bg = "black",
  fg = "white",
  frame = TRUE
)

plot.new()
plot.window(xlim = c(0, 1), ylim = c(0, 1))
leg(
  type = "grad_line",
  val = c(1.25, 4.07, 10.001, 15.071),
  pos = "top",
  lwd = c(1, 7, 15),
  col = "#C130ff",
  val_rnd = 3,
  box_cex = c(2, 1),
  title = "Graduated Lines"
)

plot.new()
plot.window(xlim = c(0, 1), ylim = c(0, 1))
set.seed(46)
x <- rnorm(10000) * 1000
val <- hist(x, breaks = quantile(x, 0:10 / 10), plot = FALSE)
leg(
  type = "histo",
  alpha = 1,
  val = val,
  pos = "top",
  pal = "Teal",
  val_rnd = 0,
  val_big = " ",
  box_border = "cornsilk",
  box_cex = c(1, 2),
  title = "Histogram"
)

plot.new()
plot.window(xlim = c(0, 1), ylim = c(0, 1))
leg(
  type = "choro_point",
  alpha = 1,
  val = c(10, 20, 30, 40, 50),
  pos = "top",
  pal = c("#7F000D", "#B56C6F", "#DBBABB", "#F1F1F1"),
  val_rnd = 2,
  col_na = "grey",
  no_data = TRUE,
  no_data_txt = "No data",
  border = "tomato4",
  cex = 1.5,
  title = "Choropleth (sequential)"
)

plot.new()
plot.window(xlim = c(0, 1), ylim = c(0, 1))
leg(
  type = "choro_line",
  alpha = 1,
  val = c(10, 20, 30, 40, 50),
  pos = "top",
  pal = c("#7F000D", "#B56C6F", "#DBBABB", "#F1F1F1"),
  val_rnd = 1,
  lwd = 4,
  col_na = "grey",
  no_data = TRUE,
  no_data_txt = "No data",
  title = "Choropleth (sequential)"
)

plot.new()
plot.window(xlim = c(0, 1), ylim = c(0, 1))
leg(
  type = "choro_symb",
  alpha = 1,
  val = c(10, 20, 30, 40, 50),
  pch = 23,
  pos = "top",
  pal = c("#7F000D", "#B56C6F", "#DBBABB", "#F1F1F1"),
  val_rnd = 1,
  lwd = 1,
  col_na = "grey",
  no_data = TRUE,
  no_data_txt = "No data",
  title = "Choropleth (sequential)"
)

plot.new()
plot.window(xlim = c(0, 1), ylim = c(0, 1))
leg(
  type = "typo_line",
  val = c("A", "B", "C"),
  lwd = 3,
  pos = "top",
  pal = c("red", "yellow", "green"),
  col_na = "black",
  no_data = TRUE,
  no_data_txt = "No data",
  box_cex = c(2, 1),
  frame = TRUE,
  title = "Typology (categories)"
)


# Positions
plot.new()
plot.window(xlim = c(0, 1), ylim = c(0, 1), asp = 1)
leg(
  type = "prop", val = c(10, 60, 100), pos = "bottomleft", adj = c(0, 4),
  title = "adj = c(0, 4)", frame = TRUE
)
leg(
  type = "choro", val = c(10, 50, 100), pos = "bottomright",
  adj = c(0, 8), title = "adj = c(0, 8)", frame = TRUE
)
leg(
  type = "prop", val = c(10, 50, 100), pos = "topleft",
  adj = c(0, -8), title = "adj = c(0, -8)"
)
box()
mtext(
  text = "A text on 1 line", side = 1, adj = .01,
  line = -1, cex = 1
)
mtext(
  text = "A text\non 2 lines", side = 1, adj = .99,
  line = -1, cex = 1
)
mtext(
  text = "A large text on 1 line", side = 3, adj = .01,
  line = -2, cex = 2
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/leg_draw.R
\name{leg_draw}
\alias{leg_draw}
\title{Plot a composed map legend}
\usage{
leg_draw(
  x,
  pos = "bottomright",
  size = 1,
  bg = "#f7f7f7",
  fg = "#333333",
  frame = TRUE,
  frame_border = fg,
  title_cex = 0.8 * size,
  val_cex = 0.6 * size,
  adj = c(0, 0),
  mar = par("mar")
)
}
\arguments{
\item{x}{list of legend parameters}

\item{pos}{position of the legend. . It can be one of 'topleft',
'topright', 'right', 'bottomright', 'bottomleft' or 'left',}

\item{size}{size of the legend; 2 means two times bigger}

\item{bg}{background color of the legend}

\item{fg}{foreground color of the legend}

\item{frame}{if TRUE the legend is plotted within a frame}

\item{frame_border}{border color of the frame}

\item{title_cex}{size of the legend title}

\item{val_cex}{size of the values in the legend}

\item{adj}{adjust the postion of the legend in x and y directions.}

\item{mar}{plot margins}
}
\value{
A composed legend is plotted. Nothing is returned.
}
\description{
Draw a map legend with several elements.
}
\examples{
# minimal example
plot.new()
plot.window(xlim = c(0, 1), ylim = c(0, 1), asp = 1)
box()
leg_comp(type = "prop", val = c(10, 50, 100)) |>
  leg_comp(type = "typo", val = c("A", "B", "C")) |>
  leg_draw(pos = "topright", bg = "lightblue")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/leg_comp.R
\name{leg_comp}
\alias{leg_comp}
\title{Compose a map legend}
\usage{
leg_comp(
  leg,
  type,
  val,
  pal = "Inferno",
  alpha = NULL,
  col = "tomato4",
  inches = 0.3,
  val_max = NULL,
  symbol = "circle",
  self_adjust = FALSE,
  lwd = 0.7,
  border = "#333333",
  pch = 1:seq_along(val),
  cex = rep(1, length(val)),
  title = "Legend Title",
  val_rnd = 0,
  val_dec = ".",
  val_big = "",
  col_na = "white",
  cex_na = 1,
  pch_na = 4,
  no_data = FALSE,
  no_data_txt = "No Data",
  box_border = "333333",
  box_cex = c(1, 1),
  horiz = FALSE
)
}
\arguments{
\item{leg}{legend object}

\item{type}{type of legend:
\itemize{
\item \strong{prop} for proportional symbols,
\item \strong{choro} for choropleth maps,
\item \strong{cont} for continuous maps (e.g. raster),
\item \strong{typo} for typology maps,
\item \strong{symb} for symbols maps,
\item \strong{prop_line} for proportional lines maps,
\item \strong{grad_line} for graduated lines maps,
\item \strong{histo} for histograms,
\item \strong{choro_point} for choropleth points maps,
\item \strong{choro_line} for choropleth lines maps,
\item \strong{choro_symb} for choropleth on symbols maps
\item \strong{typo_line} for typology lines maps.
}}

\item{val}{vector of value(s) (for "prop" and "prop_line", at least c(min, max)
for "cont"),
vector of categories (for "symb", "typo", "typo_line"),
break labels (for "choro", "choro_point", "choro_line", "choro_symb",
and "grad_line"),
histogram parameters (for "histo").}

\item{pal}{a color palette name or a vector of colors}

\item{alpha}{opacity, in the range [0,1]}

\item{col}{color of the symbols (for "prop") or color of the lines (for
"prop_line" and "grad_line")}

\item{inches}{size of the largest symbol (radius for circles, half width
for squares) in inches}

\item{val_max}{maximum value corresponding to the largest symbol or line}

\item{symbol}{type of symbols, 'circle' or 'square'}

\item{self_adjust}{if TRUE values are self-adjusted to keep min, max and
intermediate rounded values}

\item{lwd}{width(s) of the symbols borders (for "prop", "symb",
"choro_point", "choro_symb"),
width of the largest line (for "prop_line"), line width (for "choro_line"
and "typo_line"), vector of line widths (for "grad_line")}

\item{border}{symbol border color(s)}

\item{pch}{type(s) of the symbols (0:25)}

\item{cex}{size(s) of the symbols}

\item{title}{title of the legend}

\item{val_rnd}{number of decimal places of the values in
the legend}

\item{val_dec}{decimal separator}

\item{val_big}{thousands separator}

\item{col_na}{color for missing values}

\item{cex_na}{size of the symbols for missing values}

\item{pch_na}{type of the symbols for missing values}

\item{no_data}{if TRUE a "missing value" box is plotted}

\item{no_data_txt}{label for missing values}

\item{box_border}{border color of legend boxes}

\item{box_cex}{width and height size expansion for boxes, histogram or lines}

\item{horiz}{if TRUE plot an horizontal legend}
}
\value{
A list of legends parameters is returned.
}
\description{
Compose a map legend with several elements.
The "type" argument defines the
legend type.
Please note that some arguments are available for all types of legend and
some others are only relevant for specific legend types.
}
\examples{
# minimal example
plot.new()
plot.window(xlim = c(0, 1), ylim = c(0, 1), asp = 1)
box()
leg_comp(type = "prop", val = c(10, 50, 100)) |>
  leg_comp(type = "typo", val = c("A", "B", "C")) |>
  leg_draw()
}
